Package: proActiv
Title: Estimate Promoter Activity from RNA-Seq data
Version: 1.22.0
Authors@R: c(
    person(given = "Deniz",
           family = "Demircioglu",
           role = c("aut"),
           email = "ddemircioglu@gis.a-star.edu.sg",
           comment = c(ORCID = "0000-0001-7857-0407")),
    person(given = "Jonathan",
          family = "Göke",
          role = c("aut"),
          email = "gokej@gis.a-star.edu.sg"),
    person(given = "Joseph",
           family = "Lee",
           role = c("cre"),
           email = "joseph.lee@u.nus.edu"))
Description: Most human genes have multiple promoters that control the 
  expression of different isoforms. The use of these alternative promoters 
  enables the regulation of isoform expression pre-transcriptionally. 
  Alternative promoters have been found to be important in a wide number of cell
  types and diseases. proActiv is an R package that enables the analysis of 
  promoters from RNA-seq data. proActiv uses aligned reads as input, and 
  generates counts and normalized promoter activity estimates for each annotated
  promoter. In particular, proActiv accepts junction files from TopHat2 or STAR 
  or BAM files as inputs. These estimates can then be used to identify which 
  promoter is active, which promoter is inactive, and which promoters change 
  their activity across conditions. proActiv also allows visualization of 
  promoter activity across conditions.
License: MIT + file LICENSE
Encoding: UTF-8
LazyData: true
Depends: R (>= 4.0.0)
RoxygenNote: 7.3.1
Imports: AnnotationDbi, BiocParallel, data.table, dplyr, DESeq2,
        IRanges, GenomicRanges, GenomicFeatures, GenomicAlignments,
        GenomeInfoDb, ggplot2, gplots, graphics, methods, rlang,
        scales, S4Vectors, SummarizedExperiment, stats, tibble,
        txdbmaker
Suggests: GenomeInfoDbData, testthat, rmarkdown, knitr, Rtsne,
        gridExtra
URL: https://github.com/GoekeLab/proActiv
biocViews: RNASeq, GeneExpression, Transcription, AlternativeSplicing,
        GeneRegulation, DifferentialSplicing, FunctionalGenomics,
        Epigenetics, Transcriptomics, Preprocessing
VignetteBuilder: knitr
git_url: https://git.bioconductor.org/packages/proActiv
git_branch: RELEASE_3_23
git_last_commit: b2595a3
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.23
Date/Publication: 2026-04-28
NeedsCompilation: no
Packaged: 2026-04-28 23:57:47 UTC; biocbuild
Author: Deniz Demircioglu [aut] (ORCID:
    <https://orcid.org/0000-0001-7857-0407>),
  Jonathan Göke [aut],
  Joseph Lee [cre]
Maintainer: Joseph Lee <joseph.lee@u.nus.edu>

<!-- README.md is generated from README.Rmd. Please edit that file -->

![Stay proActiv\!](man/figures/proActiv_design.png)

![Stay proActiv\!](man/figures/proActiv_name.png)

## proActiv: Estimation of Promoter Activity from RNA-Seq data

<!-- badges: start -->

[![GitHub release (latest by
date)](https://img.shields.io/github/v/release/GoekeLab/proActiv)](https://github.com/GoekeLab/proActiv/releases/)
[![Maintained?](https://img.shields.io/badge/Maintained%3F-Yes-brightgreen)](https://github.com/GoekeLab/proActiv/graphs/contributors)
[![Install](https://img.shields.io/badge/Install-Github-brightgreen)](#installation)
<!-- badges: end -->

proActiv is an R package that estimates promoter activity from RNA-Seq
data. proActiv uses aligned reads and genome annotations as input, and
provides absolute and relative promoter activity as output. The package
can be used to identify active promoters and alternative promoters.
Details of the method are described in [Demircioglu et al](#reference).

HTML documentation of proActiv, including a complete step-by-step
workflow and a function manual, is available at
<https://goekelab.github.io/proActiv/>.

Additional data on differential promoters in tissues and cancers from
TCGA, ICGC, GTEx, and PCAWG is available at
<https://jglab.org/data-and-software/>.

### Content

  - [Installation](#installation)
  - [Quick Start](#quick-start)
  - [Creating a Promoter Annotation
    object](#creating-a-promoter-annotation-object)
  - [Complete Analysis Workflow: Analyzing Alternative
    Promoters](#complete-analysis-workflow-analyzing-alternative-promoters)
  - [Limitations](#limitations)
  - [Release History](#release-history)
  - [Reference](#reference)
  - [Contributors](#contributors)

### Installation

proActiv can be installed from Bioconductor:

``` r
if (!requireNamespace("BiocManager", quietly = TRUE))
    install.packages("BiocManager")

BiocManager::install("proActiv")
```

### Quick Start

proActiv estimates promoter activity from RNA-Seq data. Promoter
activity is defined as the total amount of transcription initiated at
each promoter. proActiv takes as input either BAM files or junction
files (TopHat2 or STAR), and a promoter annotation object of the
relevant genome. An optional argument `condition` can be supplied,
describing the experimental condition corresponding to each input file.
Here we demonstrate proActiv with STAR junction files (Human genome
GRCh38 GENCODE v34) as input. These files are taken from the [SGNEx
project](https://github.com/GoekeLab/sg-nex-data) but restricted to the
chr1:10,000,000-30,000,000 region, and can be found at
`extdata/vignette`:

  - `extdata/vignette/SGNEx_A549_Illumina_replicate1-run1.subset.SJ.out.tab.gz`
  - `extdata/vignette/SGNEx_A549_Illumina_replicate3-run1.subset.SJ.out.tab.gz`
  - `extdata/vignette/SGNEx_A549_Illumina_replicate5-run1.subset.SJ.out.tab.gz`
  - `extdata/vignette/SGNEx_HepG2_Illumina_replicate2-run1.subset.SJ.out.tab.gz`
  - `extdata/vignette/SGNEx_HepG2_Illumina_replicate4-run1.subset.SJ.out.tab.gz`
  - `extdata/vignette/SGNEx_HepG2_Illumina_replicate5-run1.subset.SJ.out.tab.gz`

<!-- end list -->

``` r
library(proActiv)

## List of STAR junction files as input
files <- list.files(system.file('extdata/vignette/junctions', 
                                package = 'proActiv'), full.names = TRUE)
## Vector describing experimental condition
condition <- rep(c('A549','HepG2'), each=3)
## Promoter annotation for human genome GENCODE v34
promoterAnnotation <- promoterAnnotation.gencode.v34.subset

result <- proActiv(files = files, 
                   promoterAnnotation = promoterAnnotation,
                   condition = condition)
```

`result` is a summarizedExperiment object which can be accessed as
follows:

  - `assays(results)` returns raw/normalized promoter counts,
    absolute/relative promoter activity and gene expression data  
  - `rowData(results)` returns promoter metadata and summarized absolute
    promoter activity by conditions

proActiv can also be run with BAM files as input, but an additional
parameter `genome` must be supplied:

``` r
## From BAM files - genome parameter must be provided
files <- list.files(system.file('extdata/testdata/bam', package = 'proActiv'), full.names = TRUE)
result <- proActiv(files = files, 
                   promoterAnnotation = promoterAnnotation.gencode.v34.subset,
                   genome = 'hg38')
```

### Creating a Promoter Annotation object

In order to quantify promoter activity, proActiv uses a set of promoters
based on genome annotations. proActiv allows the creation of a promoter
annotation object for any genome from a TxDb object or from a GTF file
with the `preparePromoterAnnotation` function. Users have the option to
either pass the file path of the GTF/GFF or TxDb to be used, or use the
TxDb object directly as input. proActiv includes pre-calculated promoter
annotations for the human genome (GENCODE v34). However, due to size
constraints, the annotation is restricted to the
chr1:10,000,000-30,000,000 region. Users can build full annotations by
downloading GTF files from [GENCODE](https://www.gencodegenes.org) page
and following the steps below.

Here, we demonstrate creating the subsetted promoter annotation for the
Human genome (GENCODE v34) with both GTF and TxDb:

``` r
## From GTF file path
gtf.file <- system.file('extdata/vignette/annotation/gencode.v34.annotation.subset.gtf.gz', 
                        package = 'proActiv')
promoterAnnotation.gencode.v34.subset <- preparePromoterAnnotation(file = gtf.file,
                                                                   species = 'Homo_sapiens')
## From TxDb object
txdb.file <- system.file('extdata/vignette/annotation/gencode.v34.annotation.subset.sqlite', 
                         package = 'proActiv')
txdb <- loadDb(txdb.file)
promoterAnnotation.gencode.v34.subset <- preparePromoterAnnotation(txdb = txdb, 
                                                                   species = 'Homo_sapiens')
```

The `PromoterAnnotation` object has 3 slots:

  - `intronRanges` : Intron ranges, giving the corresponding transcripts
    of each intron
  - `promoterIdMapping` : An ID mapping between transcripts, promoter
    IDs and gene IDs  
  - `promoterCoordinates` : Promoter coordinates (TSS) and internal
    promoter state, along with the 3’ coordinate of the first exon

### Complete Analysis Workflow: Analyzing Alternative Promoters

Most human genes have multiple promoters that control the expression of
distinct isoforms. The use of these alternative promoters enables the
regulation of isoform expression pre-transcriptionally. Importantly,
alternative promoters have been found to be important in a wide number
of cell types and diseases. proActiv includes a workflow to identify and
visualize alternative promoter usage between conditions. This workflow
is described in detail
[here](https://goekelab.github.io/proActiv/articles/proActiv.html).

## Release History

**Release 1.1.18**

Date: 7th April 2021

Changes in version 1.1.18:

  - Gene expression data is now stored in the `assays` of the
    summarizedExperiment object returned by `proActiv` to facilitate
    easier filtering of the summarizedExperiment object. The metadata
    slot is now empty.

  - Plotting promoter activity: Implementation of `boxplotPromoters`
    function to plot boxplots of absolute promoter activity, relative
    promoter activity, and gene expression.

  - Identification of alternative promoters: Implementation of
    `getAlternativePromoters`, used to identify promoters that may
    exhibit alternative usage.

**Release 1.0.0**

Release date: 28th October 2020

Released with Bioconductor 3.12

**Release 0.99.0**

Release date: 21st August 2020

Changes in version 0.99.0:

  - Workflow: The wrapper function `proActiv` performs all steps to
    estimate promoter activity and calculates promoter metadata. A
    `condition` argument can be supplied for `proActiv` to summarize
    promoter counts and activity across conditions. These results are
    returned as a SummarizedExperiment object.

  - BAM file usage: In addition to junction files, `proActiv` now allows
    BAM files as input. However, users should note that this function is
    not fully optimized and may have long run-time.

  - Promoter annotation: Improved efficiency in generating promoter
    annotations without the need for parallelization with the
    `preparePromoterAnnotations` function. The promoter annotation
    object is also trimmed to preserve essential information for running
    `proActiv`, in order to comply with Bioconductor guidelines
    concerning package size.

  - Plotting promoter activity: The plotting function `plotPromoters`
    visualizes promoter activity across conditions. It accepts the
    SummarizedExperiment object returned by `proActiv` along with a gene
    of interest and gene annotations as arguments. This allows users to
    visualize promoter activity and identify instances of alternative
    promoter usage.

  - Vignette: proActiv now comes with a vignette, documenting a complete
    step-by-step workflow in identifying active and alternative promoter
    usage. This includes guidance on running `proActiv`, creating
    promoter annotations and identifying alternative promoter usage.
    Various visualizations of promoter activity are also offered.

**Initial Release 0.1.0**

Release date: 19th May 2020

This release corresponds to the proActiv version used by [Demircioglu et
al.](#reference)

## Limitations

proActiv will not provide promoter activity estimates for promoters
which are not uniquely identifiable from splice junctions (single exon
transcripts, promoters which overlap with internal exons).

## Reference

If you use proActiv, please cite:

[Demircioğlu, Deniz, et al. “A Pan-cancer Transcriptome Analysis Reveals
Pervasive Regulation through Alternative Promoters.” *Cell* 178.6
(2019):
1465-1477.](https://www.cell.com/cell/fulltext/S0092-8674\(19\)30906-7)

## Contributors

proActiv is developed and maintained by [Deniz
Demircioglu](https://github.com/dnzdmrcgl), [Joseph
Lee](https://github.com/jleechung), and [Jonathan
Göke](https://github.com/jonathangoeke).

![Stay proActiv\!](man/figures/proActiv_logoName.png)

#' Prepare the absolute promoter activity table including the promoter and gene
#' ids
#'
#' @param junctionReadCounts Matrix of junction read counts (rows: promoters,
#'   cols: samples)
#' @param promoterAnnotation A PromoterAnnotation object containing the
#'   intron ranges, promoter coordinates and the promoter id mapping
#' @param log2 Logical indicating whether log2 read counts should be used
#'   (default: TRUE) or not
#' @param pseudocount Number to be used for log2 as pseudocount if log2 is TRUE
#'
#' @return data.frame of absolute promoter activity with promoter and gene ids
#'
getAbsolutePromoterActivity <- function(junctionReadCounts, promoterAnnotation,
                                        log2 = TRUE, pseudocount = 1) {
    message(paste0('Calculating ', ifelse(log2 == TRUE, 'log2 ', ''), 
                    'absolute promoter activity...'))
    promoterIdMapping <- promoterIdMapping(promoterAnnotation)
    conversionHelper <- unique(promoterIdMapping[, c('promoterId', 'geneId')])
    conversionHelper <- conversionHelper[match(rownames(junctionReadCounts), 
                                                conversionHelper$promoterId), ]
    if (log2 == TRUE & is.null(pseudocount) == FALSE) {
        junctionReadCounts <- log2(junctionReadCounts + pseudocount)
        junctionReadCounts <- as.data.frame(junctionReadCounts)
    }
    absolutePromoterActivity <- cbind(conversionHelper, junctionReadCounts)
    rownames(absolutePromoterActivity) <- conversionHelper$promoterId
    return(absolutePromoterActivity)
}

#' Prepare the gene expression table including the gene ids
#'
#' @param absolutePromoterActivity data.frame of absolute promoter activity 
#'   with promoter and gene ids
#'
#' @return data.frame of gene expression with gene ids#'
#'
getGeneExpression <- function(absolutePromoterActivity) {
    message('Calculating gene expression...')
    conversionHelper <- absolutePromoterActivity[, c('promoterId', 'geneId')]
    geneExpression <- as.matrix(apply(
        absolutePromoterActivity[, -c(1,2), drop=FALSE], 2, tapply, 
        conversionHelper$geneId, sum, na.rm = TRUE))
    counts <- as.numeric(table(conversionHelper$geneId))
    geneExpression <- geneExpression[rep(seq_len(nrow(geneExpression)), 
                                         times = counts),]
    geneExpression <- data.frame(geneExpression, row.names = NULL)
    colnames(geneExpression) <- colnames(absolutePromoterActivity)[-c(1,2)]
    geneExpression <- cbind(geneId = conversionHelper$geneId, geneExpression)
}

#' Prepare the relative promoter activity table including the promoter and gene
#' ids
#'
#' @param absolutePromoterActivity data.frame of absolute promoter activity with
#'   promoter and gene ids
#' @param geneExpression data.frame of gene expression with gene ids
#'
#' @return data.frame of relative promoter activity with promoter and gene ids
#'
getRelativePromoterActivity <- function(absolutePromoterActivity, 
                                        geneExpression) {
    message(paste0('Calculating relative promoter activity...'))
    conversionHelper <- absolutePromoterActivity[, c('promoterId', 'geneId')]
    if (is.null(geneExpression) == TRUE) {
        geneExpression <- getGeneExpression(absolutePromoterActivity)
    }
    matchedGeneExpression <- geneExpression[match(conversionHelper$geneId, 
                                                    geneExpression$geneId), ]
    relativePromoterActivity <- absolutePromoterActivity[, -c(1,2)] / 
                                                    matchedGeneExpression[, -1]
    relativePromoterActivity <- cbind(conversionHelper, 
                                                    relativePromoterActivity)
    names(relativePromoterActivity) <- names(absolutePromoterActivity)
    return(relativePromoterActivity)
}

#' Calculate the total number of junction reads overlapping with the introns of
#' each promoter for the input junction file
#'
#' @param promoterCoordinates A GRanges object containing promoter coordinates
#'   and reduced exon coordinates by gene
#' @param intronRanges A Granges object containing the annotated unique intron
#'   ranges. These ranges will be used for counting the reads
#' @param file character path for the input junction bed or bam file
#' @param fileType character type of the junction bed file. Either 'tophat',
#'   'star' or 'bam'
#' @param genome character genome version
#'
#' @return The total number of junction reads overlapping with each promoter for
#'   the input annotated intron ranges
#' 
#' @importFrom GenomicAlignments readTopHatJunctions readSTARJunctions 
#'   readGAlignments summarizeJunctions
#' @importFrom GenomeInfoDb seqlevelsStyle keepStandardChromosomes
#' @importFrom GenomicRanges findOverlaps 'strand<-' 
#' @importFrom S4Vectors queryHits subjectHits
calculateJunctionReadCounts <- function(promoterCoordinates, intronRanges, 
                                        file = '', fileType = '', genome = '') {
    if(fileType == 'tophat') {
        message(paste0('Processing: ', file))
        junctionTable <- GenomicAlignments::readTopHatJunctions(file)
        GenomeInfoDb::seqlevelsStyle(junctionTable) <- 'UCSC'
        message('File loaded into memory')
    } else if(fileType == 'star') {
        message(paste0('Processing: ', file))
        junctionTable <- GenomicAlignments::readSTARJunctions(file)
        GenomeInfoDb::seqlevelsStyle(junctionTable) <- 'UCSC'
        junctionTable$score <- junctionTable$um_reads  
        message('File loaded into memory')
    } else if (fileType == 'bam') {
        message(paste0('Processing: ', file))
        rawBam <- GenomicAlignments::readGAlignments(file)
        bam <- GenomeInfoDb::keepStandardChromosomes(rawBam, 
                                                     pruning.mode = 'coarse')
        GenomeInfoDb::seqlevelsStyle(bam) <- 'UCSC'
        rm(rawBam)
        gc()
        junctions <- GenomicAlignments::summarizeJunctions(bam, genome = genome)
        rm(bam)
        gc()
        junctionTable <- GenomeInfoDb::keepStandardChromosomes(junctions, 
                                                    pruning.mode = 'coarse')
        strand(junctionTable) <- junctionTable$intron_strand
        junctionTable <- junctionTable[,c('score')]
        message('Junctions extracted from BAM file')
    }
    message('Calculating junction counts')
    intronRanges.overlap <- GenomicRanges::findOverlaps(intronRanges, 
                                                        junctionTable, 
                                                        type = 'equal')
    intronRanges$junctionCounts <- rep(0, length(intronRanges))
    intronRanges$junctionCounts[queryHits(intronRanges.overlap)] <- 
                        junctionTable$score[subjectHits(intronRanges.overlap)]
    intronIdByPromoter <- as.vector(promoterCoordinates$intronId)
    intronId.unlist <- unlist(intronIdByPromoter)
    levels.tmp <- unique(promoterCoordinates$promoterId)
    levels.tmp <- levels.tmp[order(levels.tmp)]
    promoterId.unlist <- factor(rep(promoterCoordinates$promoterId, 
                                vapply(intronIdByPromoter, FUN = length, 
                                FUN.VALUE = numeric(1))), levels = levels.tmp)

    junctionCounts <- tapply(intronRanges$junctionCounts[intronId.unlist], 
                                promoterId.unlist, sum)
    names(junctionCounts) <- promoterCoordinates$promoterId
    return(junctionCounts)
}

#' Calculate the promoter read counts using junction read counts approach for
#' all the input junction files
#'
#' @param promoterAnnotation A PromoterAnnotation object containing the
#'   reduced exon ranges, annotated intron ranges, promoter coordinates and the
#'   promoter id mapping
#' @param files A character vector. The list of junction or BAM files 
#'   for which the junction read counts will be calculated
#' @param fileLabels A character vector. The labels of junction or BAM 
#'   files for which the junction read counts will be calculated. These labels 
#'   will be used as column names for the output data.frame object
#' @param fileType A character. Type of the junction bed or bam file, either
#'   'tophat', 'star' or 'bam
#' @param genome A character. Genome version used. Must be specified if input is
#'  a BAM file. Defaults to NULL
#' @param numberOfCores A numeric value. The number of cores to be used for
#'   counting junction reads. Defaults to 1 (no parallelization). This parameter
#'   will be used as an argument to BiocParallel::bplapply
#'
#' @return A data.frame object. The number of junction reads per promoter (rows)
#'   for each sample (cols)
#' @importFrom BiocParallel bpparam bplapply
calculatePromoterReadCounts <- function(promoterAnnotation, files = NULL, 
                                        fileLabels = NULL, fileType = NULL , 
                                        genome = NULL, numberOfCores = 1) {
    promoterCoordinates <- promoterCoordinates(promoterAnnotation)
    intronRanges <- intronRanges(promoterAnnotation)
    if (numberOfCores > 1 & 
        requireNamespace('BiocParallel', quietly = TRUE) == TRUE) {
        bpParameters <- BiocParallel::bpparam()
        bpParameters$workers <- numberOfCores
        promoterReadCounts <- BiocParallel::bplapply(files, 
                                    calculateJunctionReadCounts, 
                                    promoterCoordinates = promoterCoordinates,
                                    intronRanges = intronRanges, 
                                    fileType = fileType, genome = genome, 
                                    BPPARAM = bpParameters)
    } else {
        if (requireNamespace('BiocParallel', quietly = TRUE) == FALSE) {
            message('Warning: "BiocParallel" package is not available! 
                    Using sequential version instead...')
        }
        promoterReadCounts <- lapply(files, calculateJunctionReadCounts, 
                                    promoterCoordinates = promoterCoordinates,
                                    intronRanges = intronRanges, 
                                    fileType = fileType, genome = genome)
    }
    if (length(files) == 1) {
        promoterReadCounts <- data.frame(counts = promoterReadCounts)
    } else {
        promoterReadCounts <- as.data.frame(promoterReadCounts)
    }
    rownames(promoterReadCounts) <- promoterCoordinates$promoterId
    colnames(promoterReadCounts) <- fileLabels
    return(promoterReadCounts)
}


#' Normalize promoter read counts using DESeq2
#'
#' @param promoterReadCounts A data.frame object. The number of junction reads
#'   per promoter (rows) for each sample (cols)
#'
#' @return A data.frame object. The normalized number of junction reads per
#'   promoter (rows) for each sample (cols) using DESeq2 counts function.
#'   Requires 'DESeq2' package to be installed
#' 
#' @importFrom DESeq2 DESeqDataSetFromMatrix estimateSizeFactors counts
normalizePromoterReadCounts <- function(promoterReadCounts) {
    if (ncol(promoterReadCounts) == 1) {
        return(promoterReadCounts)
    }
    activePromoters <- which(!is.na(promoterReadCounts[, 1]))
    colData <- data.frame(sampleLabels = colnames(promoterReadCounts))
    rownames(colData) <- colnames(promoterReadCounts)

    message('Calculating normalized read counts...')
    if (requireNamespace('DESeq2', quietly = TRUE) == FALSE) {
        stop('DESeq2 is not installed! 
                For normalization DESeq2 is needed, please install it.')
    }
    dds <- DESeq2::DESeqDataSetFromMatrix(countData = 
                                        promoterReadCounts[activePromoters, ], 
                                        colData = colData, design = ~ 1)
    dds <- DESeq2::estimateSizeFactors(dds)
    promoterReadCounts[activePromoters, ] <- DESeq2::counts(dds, 
                                                            normalized = TRUE)
    return(promoterReadCounts)
}

# Get the transcript ranges with metadata and transcript lengths
#' @importFrom GenomeInfoDb keepStandardChromosomes 'seqlevelsStyle<-'
#' @importFrom GenomicFeatures transcripts
getTranscriptRanges <- function(txdb, species = 'Homo_sapiens') {
    # Retrieve transcript ranges with detailed metadata
    transcriptRanges <- transcripts(txdb, columns = 
                            c('TXID', 'TXSTART', 'TXEND', 'GENEID', 'TXNAME'))
    names(transcriptRanges) <- transcriptRanges$TXNAME
    transcriptRanges <- 
        tryCatch(keepStandardChromosomes(x = transcriptRanges, 
                                        species = species, 
                                        pruning.mode = "tidy"), 
                error = function(cond) keepStandardChromosomes(transcriptRanges,
                                        pruning.mode = "tidy"))
    GenomeInfoDb::seqlevelsStyle(transcriptRanges) <- 'UCSC'
    return(transcriptRanges)
}

# Get transcript start site coordinates
#' @importFrom GenomeInfoDb keepStandardChromosomes 'seqlevelsStyle<-'
#' @importFrom GenomicFeatures promoters
getTssRanges <- function(transcriptRanges) {
    # Annotate transcription start sites (TSSs) with ids
    tssCoordinates <- promoters(transcriptRanges, upstream = 0, downstream = 1)
    seqlevelsStyle(tssCoordinates) <- 'UCSC'
    tssCoordinates.unique <- unique(tssCoordinates)
    tssCoordinates.unique$tssId <- paste0('tss.',
                                        seq_len(length(tssCoordinates.unique)))
    tssCoordinates.overlap <- findOverlaps(tssCoordinates, 
                                            tssCoordinates.unique, 
                                            type = 'equal')
    tssCoordinates$tssId <- tssCoordinates.unique$tssId[
                                            subjectHits(tssCoordinates.overlap)]
    return(tssCoordinates)
}

# Get exon ranges for each transcript
#' @importFrom GenomeInfoDb keepStandardChromosomes
#' @importFrom GenomeInfoDb 'seqlevelsStyle<-'
#' @importFrom GenomicFeatures exonsBy
getExonRangesByTx <- function(txdb, species = 'Homo_sapiens') {
    exonRangesByTx <- exonsBy(txdb, by = 'tx', use.names = TRUE)
    exonRangesByTx <- 
        tryCatch(keepStandardChromosomes(x = exonRangesByTx, 
                                        species = species, 
                                        pruning.mode = "tidy"), 
                error = function(cond) keepStandardChromosomes(exonRangesByTx,
                                        pruning.mode = "tidy"))
    seqlevelsStyle(exonRangesByTx) <- 'UCSC'
    return(exonRangesByTx)
}

# Get the first exon of each transcript
getFirstExonRanges <- function(exonRangesByTx.unlist) {
    exonRanges.firstExon <- exonRangesByTx.unlist[
                                        exonRangesByTx.unlist$exon_rank == 1]
    exonRanges.firstExon$tx_name <- names(exonRanges.firstExon)
    exonRanges.firstExon$customId <- seq_len(length(exonRanges.firstExon))
    return(exonRanges.firstExon)
}

# Reduce all first exons for each gene to identify transcripts 
# belonging to each promoter
#' @importFrom rlang .data
#' @importFrom dplyr as_tibble '%>%' arrange group_by mutate lead summarise 
#'   ungroup select n 
#' @importFrom S4Vectors mcols 'mcols<-'
#' @importFrom GenomicRanges makeGRangesFromDataFrame
getReducedExonRanges <- function(exonRanges.firstExon, 
                                exonRanges.firstExon.geneId) {
    exonRanges.firstExon$geneId <- exonRanges.firstExon.geneId
    exonReducedRanges <- as_tibble(exonRanges.firstExon) %>% 
        dplyr::arrange(.data$geneId, .data$start) %>% 
        dplyr::group_by(.data$geneId) %>%
        dplyr::mutate(exonClass = 
                c(0, cumsum(lead(.data$start) > cummax(.data$end))[-n()])) %>%
        dplyr::group_by(.data$geneId, .data$exonClass, 
                        .data$seqnames, .data$strand) %>%
        dplyr::summarise(start = min(.data$start), 
                            end = max(.data$end), 
                            customId = list(.data$customId),
                            .groups = 'drop') %>%
        dplyr::ungroup() %>%
        dplyr::select(.data$seqnames, .data$start, 
                        .data$end, .data$strand, .data$customId)
    exonReducedRanges$promoterId <- seq_len(nrow(exonReducedRanges))
    exonReducedRanges <- makeGRangesFromDataFrame(exonReducedRanges, 
                                                    keep.extra.columns = TRUE)
    names(mcols(exonReducedRanges)) <- c('revmap', 'promoterId')
    return(exonReducedRanges)
}

# Get intron ranges for each promoter
#' @importFrom GenomeInfoDb keepStandardChromosomes 'seqlevelsStyle<-'
#' @importFrom GenomicFeatures intronsByTranscript
getIntronRangesByTx <- function(txdb, transcriptRanges, 
                                species = 'Homo_sapiens') {
    # Retrieve intron ranges for each promoter
    intronRangesByTx <- intronsByTranscript(txdb, use.names = TRUE)
    intronRangesByTx <- 
        tryCatch(keepStandardChromosomes(x = intronRangesByTx, 
                                        species = species, 
                                        pruning.mode = "tidy"), 
                error = function(cond) keepStandardChromosomes(intronRangesByTx,
                                        pruning.mode = "tidy"))
    seqlevelsStyle(intronRangesByTx) <- 'UCSC'
    intronRangesByTx <- intronRangesByTx[names(transcriptRanges)]
    return(intronRangesByTx)
}

# Get unique intron ranges with custom ids
getUniqueIntronRanges <- function(intronRangesByTx.unlist) {
    # Annotate unique intron ranges  with unique ids
    intronRanges.unique <- unique(intronRangesByTx.unlist)
    intronRanges.unique <- sort(intronRanges.unique)
    intronRanges.unique$INTRONID <- seq_len(length(intronRanges.unique))
    names(intronRanges.unique) <- NULL
    return(intronRanges.unique)
}

# Get the rank of each intron within the transcript (similar to exon ranges)
#' @importFrom rlang .data
#' @importFrom dplyr as_tibble mutate group_by '%>%' row_number
getIntronRanks <- function(intronRangesByTx) {
    intronRankByTx <- as_tibble(intronRangesByTx) %>% 
        dplyr::group_by(.data$group_name) %>% 
        dplyr::mutate(rank = ifelse(.data$strand == '+', 
                                    row_number(), rev(row_number())))
    intronRank <- intronRankByTx$rank
    return(intronRank)
}

# Annotate all the intron ranges with the metadata
annotateAllIntronRanges <- function(intronRankByTx, intronRangesByTx.unlist, 
                                    transcriptRanges, promoterIdMapping) {
    # Annotate all intron ranges with corresponding ids
    intronRangesByTx.unlist$INTRONRANK <- intronRankByTx
    intronRangesByTx.unlist$TXID <- transcriptRanges$TXID[match(
                    names(intronRangesByTx.unlist), transcriptRanges$TXNAME)]
    intronRangesByTx.unlist$TXSTART <- transcriptRanges$TXSTART[match(
                    names(intronRangesByTx.unlist), transcriptRanges$TXNAME)]
    intronRangesByTx.unlist$TXEND <- transcriptRanges$TXEND[match(
                    names(intronRangesByTx.unlist), transcriptRanges$TXNAME)]
    intronRangesByTx.unlist$GENEID <- as.character(transcriptRanges$GENEID)[
                    match(names(intronRangesByTx.unlist), 
                    transcriptRanges$TXNAME)]
    intronRangesByTx.unlist$TXNAME <- transcriptRanges$TXNAME[match(
                    names(intronRangesByTx.unlist), transcriptRanges$TXNAME)]
    intronRangesByTx.unlist$TxWidth <- transcriptRanges$TxWidth[match(
                    names(intronRangesByTx.unlist), transcriptRanges$TXNAME)]
    intronRangesByTx.unlist$promoterId <- promoterIdMapping$promoterId[match(
                    intronRangesByTx.unlist$TXID, 
                    promoterIdMapping$transcriptId)]
    names(intronRangesByTx.unlist) <- NULL
    return(intronRangesByTx.unlist)
}

# Annotate unique intron ranges with metadata
annotateUniqueIntronRanges <- function(intronRanges.unique, 
                                        intronRangesByTx.unlist) {
    # Annotate unique intron ranges with corresponding ids
    intronRanges.unique$INTRONRANK <- as(split(
                                            intronRangesByTx.unlist$INTRONRANK, 
                                            intronRangesByTx.unlist$INTRONID), 
                                            'IntegerList')
    intronRanges.unique$TXID <- as(split(intronRangesByTx.unlist$TXID, 
                                            intronRangesByTx.unlist$INTRONID), 
                                            'IntegerList')
    intronRanges.unique$TXSTART <- as(split(intronRangesByTx.unlist$TXSTART, 
                                            intronRangesByTx.unlist$INTRONID), 
                                            'IntegerList') 
    intronRanges.unique$TXEND <- as(split(intronRangesByTx.unlist$TXEND, 
                                            intronRangesByTx.unlist$INTRONID), 
                                            'IntegerList')
    intronRanges.unique$GENEID <- as(split(intronRangesByTx.unlist$GENEID, 
                                            intronRangesByTx.unlist$INTRONID), 
                                            'CharacterList')
    intronRanges.unique$TXNAME <- as(split(intronRangesByTx.unlist$TXNAME, 
                                            intronRangesByTx.unlist$INTRONID), 
                                            'CharacterList')
    intronRanges.unique$TxWidth <- as(split(intronRangesByTx.unlist$TxWidth, 
                                            intronRangesByTx.unlist$INTRONID), 
                                            'IntegerList')
    intronRanges.unique$promoterId <- as(split(
                                            intronRangesByTx.unlist$promoterId, 
                                            intronRangesByTx.unlist$INTRONID), 
                                            'CharacterList')
    return(intronRanges.unique)
}

# Prepare metadata for each unique intron range considering all of its uses 
# across transcripts
#' @importFrom rlang .data
#' @importFrom dplyr as_tibble mutate group_by '%>%' filter distinct inner_join
#' @importFrom S4Vectors mcols
getIntronTable <- function(intronRanges.unique, intronRangesByTx.unlist) {
    intronTable <- as_tibble(as.data.frame(intronRanges.unique)) 
    # Prepare metadata for each intron
    intronRangesByTx.metadata <- as_tibble(as.data.frame(
                                            mcols(intronRangesByTx.unlist)))
    intronRangesByTx.metadata <- mutate(
                group_by(intronRangesByTx.metadata, .data$TXNAME), 
                IntronEndRank = max(.data$INTRONRANK) - .data$INTRONRANK + 1)
    intronRangesByTx.metadata <- mutate(
                group_by(intronRangesByTx.metadata, .data$INTRONID),
                MinIntronRank = min(.data$INTRONRANK))
    intronRangesByTx.metadata <- mutate(
                group_by(intronRangesByTx.metadata, .data$INTRONID), 
                MaxIntronRank = max(.data$INTRONRANK))

    intronRangesByTx.metadata.unique <- group_by(intronRangesByTx.metadata, 
                                                    .data$INTRONID) %>%
        filter(.data$INTRONRANK == .data$MinIntronRank) %>%
        mutate(TxWidthMax = max(.data$TxWidth)) %>%
        dplyr::select(.data$INTRONID, .data$MinIntronRank, 
                        .data$MaxIntronRank, .data$TxWidthMax) %>%
        dplyr::rename(MinIntronRankTxWidthMax = .data$TxWidthMax) %>%
        distinct()

    intronTable <- inner_join(intronTable, 
                            intronRangesByTx.metadata.unique, by = 'INTRONID')
    return(intronTable)
}

# Get the ids of introns contributing to the transcription for each promoter
getIntronIdPerPromoter <- function(intronRangesByTx.unlist, promoterIdMapping) {
    intronRanges.firstIntron <- intronRangesByTx.unlist[
                                intronRangesByTx.unlist$INTRONRANK == 1]
    intronIdByPromoter.firstIntron <- split(intronRanges.firstIntron$INTRONID, 
                                factor(intronRanges.firstIntron$promoterId, 
                                        levels = seq_len(length(
                                        unique(promoterIdMapping$promoterId)))))
    intronIdByPromoter.firstIntron <- lapply(intronIdByPromoter.firstIntron, 
                                                unique)
    return(intronIdByPromoter.firstIntron)
}

# Get the metadata for each promoter regarding the use of introns
#' @importFrom rlang .data
#' @importFrom dplyr group_by mutate filter distinct n
getPromoterMetadata <- function(intronTable.firstIntron) {
    ## Extract per promoter information from intronTable
    promoterMetadata <- group_by(intronTable.firstIntron, .data$promoterId) %>%
        mutate(MinMergedIntronRank = min(.data$MinIntronRank),
            MaxMergedIntronRank = max(.data$MaxIntronRank),
            MaxMergedIntronTxWidth = max(.data$MinIntronRankTxWidthMax)) %>%
        filter(.data$MinIntronRank == min(.data$MinIntronRank)) %>%
        dplyr::select(.data$promoterId, .data$MinMergedIntronRank, 
                .data$MaxMergedIntronRank, .data$MaxMergedIntronTxWidth) %>%
        distinct()
    return(promoterMetadata)
}

# Annotate the reduced exon ranges for each promoter with the intron metadata
#' @importFrom IRanges IRanges 
#' @importFrom S4Vectors mcols<- mcols
annotateReducedExonRanges <- function(exonReducedRanges, promoterMetadata, 
                                        intronIdByPromoter.firstIntron) {
    intronReducedTable <- cbind(as.data.frame(exonReducedRanges), 
            as.data.frame(promoterMetadata[match(exonReducedRanges$promoterId, 
                                            promoterMetadata$promoterId), -1]))
    exonReducedRanges <- GRanges(intronReducedTable$seqnames,
                            ranges = IRanges(start = intronReducedTable$start, 
                                            intronReducedTable$end),
                                            strand = intronReducedTable$strand)
    exonReducedRanges$intronId <- as(intronIdByPromoter.firstIntron, 
                                            'IntegerList')
    mcols(exonReducedRanges) <- cbind(mcols(exonReducedRanges), 
            intronReducedTable[, c('promoterId', 'MinMergedIntronRank', 
                            'MaxMergedIntronRank', 'MaxMergedIntronTxWidth')])
    return(exonReducedRanges)
}

# Annotate all unique introns with the promoter metadata
#' @importFrom methods as
annotateIntronRanges <- function(intronRanges.unique, intronTable) {
    # Annotate unique intron ranges
    intronRanges.annotated <- intronRanges.unique
    intronRanges.annotated$MinIntronRank <- intronTable$MinIntronRank
    intronRanges.annotated$MaxIntronRank <- intronTable$MaxIntronRank
    intronRanges.annotated$MinIntronRankTxWidthMax <- 
        intronTable$MinIntronRankTxWidthMax
    return(intronRanges.annotated)
}

# Helper to parse input file
#' @importFrom AnnotationDbi loadDb
#' @importFrom txdbmaker makeTxDbFromGFF
parseTxdb <- function(txdb, file, species) {
    
    if (missing(txdb) & missing(file)) {
        stop('Either `txdb` or `file` argument must be provided')
    } else if (!missing(txdb) & !missing(file)) {
        stop('Both `txdb` and `file` arguments are provided: 
                Please specify only one')
    } else if (missing(txdb)) {
        ## Parse input file
        checkFile <- file.exists(file)
        if (!checkFile) {
            stop(paste0('Error: Please specify a valid file path'))
        }
        ext <- tools::file_ext(file)
        if (ext %in% c('gz', 'bz2', 'xz')){
            file.tmp <- gsub(paste0('\\.', ext), '', file)
            ext <- unique(tools::file_ext(file.tmp))
        }
        if (!(ext %in% c('gtf', 'sqlite', 'gff3'))) {
            stop('File path must link to a GTF/GFF or TxDb object')
        }
        message('Parsing input file...')
        if (ext == 'sqlite') {
            txdb <- AnnotationDbi::loadDb(file)
        } else if (ext %in% c('gtf', 'gff3')) {
            txdb <- txdbmaker::makeTxDbFromGFF(file = file,
                                            format = ext,
                                            organism = sub('_', ' ', species))
        }
    }
    return(txdb)
}

# Re-exports

# AnnotationDbi

#' @importFrom AnnotationDbi loadDb
#' @export
AnnotationDbi::loadDb

# summarizedExperiment 

#' @importFrom SummarizedExperiment assays
#' @export
SummarizedExperiment::assays

#' @importFrom SummarizedExperiment rowData
#' @export
SummarizedExperiment::rowData

#' @importFrom SummarizedExperiment colData
#' @export
SummarizedExperiment::colData

# dplyr

#' @importFrom dplyr as_tibble
#' @export
dplyr::as_tibble

#' @importFrom dplyr '%>%'
#' @export
dplyr::`%>%`

#' @importFrom dplyr group_by
#' @export
dplyr::group_by

#' @importFrom dplyr mutate
#' @export
dplyr::mutate

#' @importFrom dplyr filter
#' @export
dplyr::filter

#' @importFrom dplyr n
#' @export
dplyr::n

#' @importFrom dplyr arrange
#' @export
dplyr::arrange

#' @importFrom tibble rownames_to_column
#' @export
tibble::rownames_to_column

# (DEPRECATED) Visualizes promoter activity and transcript model for a gene of 
# interest
#
# @param result A SummarizedExperiment object with assays giving promoter 
#   counts,activity and gene expression and promoter gene id mapping stored as
#   row data
# @param gene A character vector of length 1. Single gene of interest to 
#   be plotted
# @param txdb A TxDb object. The txdb must correspond to the genome version 
#   used in running proActiv. Here, it is recommended to use the same txdb in 
#   generating promoter annotations
# @param ranges A list of GRanges. Each entry in the list should correspond to 
#   a transcript that will be visualized, with Genomic Ranges giving the exons 
#   corresponding to that transcript 
# @param cex.title A numeric value. Size of axis labels. Defaults to 0.9
# @param cex.axis A numeric value. Size of axis and axis ticks. Defaults to 0.9
# @param cex.main A numeric value. Size of plot name. Defaults to 1
# @param blk.width A numeric value. The width of promoters blocks in the 
#   data track. Defaults to 500 (bases)
# @param blk.fill A character vector of length 1. The fill colour of the 
#   promoter blocks in the data track. Defaults to 'grey' 
# @param blk.border A character vector of length 1. The border colour of the 
#   promoter blocks in the data track. Defaults to 'darkgrey'
# @param label.col A character vector of length 1. The font colour of the 
#   promoter ID label in the annotation track. Defaults to 'black'
# @param label.size A numeric value. The size of the promoter ID label in the 
#   annotation track. Defaults to 0.7
# @param arrow.width A numeric value. The width of promoter arrows in the 
#   annotation track. This value is internally calculated based on the gene 
#   of interest 
# @param arrow.fill A character vector of length 1. The fill colour of the 
#   promoter arrows in the annotation track. Defaults to 'transparent'
# @param arrow.border A character vector of length 1. The border colour of 
#   the promoter arrows in the annotation track. Defaults to 'grey'
# 
# @export
# @return Outputs a plot of the promoters of the gene of interest across 
#   conditions, along with a model of transcripts belonging to the gene 
#   
# @examples 
#  
# ## First, run proActiv to generate a summarizedExperiment result
# files <- list.files(system.file('extdata/vignette/junctions', 
#                       package = 'proActiv'), 
#                       full.names = TRUE)
# promoterAnnotation <- promoterAnnotation.gencode.v34.subset
# result <- proActiv(files = files,
#                        promoterAnnotation  = promoterAnnotation,
#                        condition = rep(c('A549','HepG2'), each=3),
#                        ncores = 1)
# ## Read in pre-computed ranges
# txdb <- AnnotationDbi::loadDb(system.file('extdata/vignette/annotations',
#                                   'gencode.v34.annotation.rap1gap.sqlite',
#                                   package = 'proActiv'))
# ## Declare a gene of interest
# gene <- 'ENSG00000076864.19'
# ## Call plot 
# plotPromoters(result = result, gene = gene, txdb = txdb)
#                            
# @importFrom Gviz plotTracks GenomeAxisTrack
# @importFrom SummarizedExperiment rowData colData
# @importFrom S4Vectors complete.cases
# plotPromoters <- function(result, gene, txdb, ranges,
#                             cex.title = 0.9, cex.axis = 0.9, cex.main = 1,
#                             blk.width = 500, blk.fill = 'grey',
#                             blk.border = 'darkgrey',
#                             label.col = 'black', label.size = 0.7,
#                             arrow.width = NULL, arrow.fill = 'transparent', 
#                             arrow.border = 'grey') {
#     result.gene <- result[rowData(result)$geneId == gene, ]
#     rdata <- rowData(result.gene)[complete.cases(rowData(result.gene)),]
#     groups <- unique(colData(result.gene)$condition)
# 
#     if (nrow(rdata) == 0) {
#         stop('Gene ID selected is either not present or has only one transcript 
#             which is a single-exon transcript. proActiv does not estimate 
#             promoter activity in such cases.')
#     }
#     message(paste0('Plotting ', gene))
#     
#     grtrack <- getGeneRegionTrack(rdata, gene, txdb, ranges)
#     dtracklist <- getDataTrack(rdata, groups, blk.width = blk.width,
#                                 fill.histogram = blk.fill, 
#                                 col.histogram = blk.border)
#     atrack <- getAnnotationTrack(rdata, grtrack, arrow.width = arrow.width,
#                                 fontcolor.feature = label.col,
#                                 cex.feature = label.size,
#                                 fill = arrow.fill, col = arrow.border)
#     gtrack <- GenomeAxisTrack()
#     
#     message('Creating Plot...')
#     plotTracks(c(grtrack, dtracklist, atrack, gtrack), type='histo', 
#                 main = gene, col.axis = 'black', col.title = 'black', 
#                 background.title = 'transparent', cex.title = cex.title, 
#                 cex.axis = cex.axis, cex.main = cex.main)
#     }

# (Deprecated) Helper function to get data track
# @importFrom GenomicRanges GRanges values
# @importFrom Gviz DataTrack
# @importFrom IRanges IRanges
# @importFrom S4Vectors 'mcols<-' mcols 'values<-'
# getDataTrack <- function(rdata, groups, blk.width,
#                             fill.histogram, col.histogram) {
#     message('Creating Data Track...')
#     ## Set dummy width for visualization
#     if (is.null(blk.width)) {
#         blk.width <- blk.width
#     }
#     blk.offset <- 0
#     if (unique(rdata$strand) == '-') {
#         blk.offset <- -blk.width
#     } 
#     ## GRanges summarizing promoter activity and coordinates
#     gr <- GRanges(seqnames = rdata$seqnames, 
#                     strand = rdata$strand,
#                     ranges = IRanges(start = rdata$start + blk.offset, 
#                                         width = blk.width)) 
#     values(gr) <- rdata[,grep('mean', colnames(rdata))]
#     names(mcols(gr)) <- gsub('.mean', '', names(mcols(gr)))
# 
#     ## Set max y limit
#     maxy <- max(unlist(mcols(gr))) + 0.5
#     dtracklist <- vector("list", length(groups))
#     for (i in seq_len(length(groups))) {
#         dtracklist[[i]] <- DataTrack(gr[,groups[i]], 
#                                     name = groups[i], ylim = c(0, maxy),
#                                     fill.histogram = fill.histogram,
#                                     col.histogram = col.histogram)
#     }
#     return(dtracklist)
#     }

# Helper function to get gene region track
# @importFrom GenomicFeatures exonsBy
# @importFrom Gviz GeneRegionTrack
# @importFrom GenomicRanges GRangesList
# getGeneRegionTrack <- function(rdata, gene, txdb, ranges) {
#     message('Creating Gene Region Track...')
#     txs.gene <- rdata$txId[[1]]
#     if ( missing(txdb) & missing(ranges)) {
#         stop('Either txdb or ranges must be provided')
#     } else if (!missing(txdb) & !missing(ranges)) {
#         stop('Both `txdb` and `ranges` arguments are provided: 
#                 Please specify only one')
#     } else if (missing(ranges)) {
#         exons.gene <- suppressWarnings(exonsBy(txdb, by = 'tx', 
#                                                use.names = TRUE)[txs.gene])
#     } else {
#         exons.gene <- ranges
#     }
#     gene.model <- as(GRangesList(exons.gene), 'data.frame')
#     gene.model <- gene.model[,c('seqnames','start','end'
#                                 ,'strand','group_name')]
#     colnames(gene.model)[1] <- 'chromosome'
#     colnames(gene.model)[5] <- 'transcript'
#     
#     grtrack <- GeneRegionTrack(gene.model,
#                             transcriptAnnotation = 'transcript',
#                             name = as.character(gene.model$chromosome[1]))
#     return(grtrack)
#     }

# Helper function to get annotation track
# @importFrom Gviz AnnotationTrack
# @importFrom GenomicRanges start end
# getAnnotationTrack <- function(rdata, grtrack, arrow.width,
#                                 fontcolor.feature, cex.feature, 
#                                 fill, col) {
#     message('Creating Annotation Track...')
#     ## Adjust arrow start depending on stand - Gviz quirks
#     if (is.null(arrow.width)) {
#         min.coord <- min(c(start(grtrack), end(grtrack)))
#         max.coord <- max(c(start(grtrack), end(grtrack)))
#         arrow.width <- diff(c(min.coord, max.coord))/sqrt(nrow(rdata)+1)
#     }
#     arrow.offset <- 0
#     if (unique(rdata$strand) == '-') {
#         arrow.offset <- -arrow.width
#     } 
#     atrack <- AnnotationTrack(start = rdata$start + arrow.offset, 
#                             width = arrow.width,
#                             chromosome = rdata$seqnames, 
#                             strand = rdata$strand,
#                             group = paste0('prmtr.', rdata$promoterId),
#                             featureAnnotation = 'group', name = '',
#                             fontcolor.feature = fontcolor.feature,
#                             cex.feature = cex.feature,
#                             fill = fill, col = col)
#     return(atrack)
#     }

### PromoterAnnotation Class Definition ###

#' S4 class for promoter annotation data for a specific annotation version
#'
#' @slot intronRanges A GRanges object. The intron ranges annotated with the 
#'   promoter information.
#' @slot promoterIdMapping A data.frame object. The id mapping between 
#'   transcript ids, names, TSS ids, promoter ids and gene ids.
#' @slot promoterCoordinates A GRanges object. Promoter coordinates (TSS) with 
#'   gene id and internal promoter state
#'
#' @importFrom GenomicRanges GRanges
#'
#' @name PromoterAnnotation-class
#' @rdname PromoterAnnotation-class
#' @exportClass PromoterAnnotation

setClass(
    "PromoterAnnotation",
    slots = c(
        intronRanges = "GRanges",
        promoterIdMapping = "data.frame",
        promoterCoordinates = "GRanges"
    ),
    prototype = list(
        intronRanges = GenomicRanges::GRanges(),
        promoterIdMapping = data.frame(),
        promoterCoordinates = GenomicRanges::GRanges()
    )
)

###################
### Constructor ###

#' @param intronRanges A GRanges object containing annotated intron ranges
#' @param promoterIdMapping A data.frame containing mapping between transcript, 
#'   TSS, promoter and gene ids
#' @param promoterCoordinates A GRanges object containing promoter coordinates
#'
#' @name PromoterAnnotation
#' @rdname PromoterAnnotation-class
#'
#' @importFrom methods new
#' @importFrom GenomicRanges GRanges
#' 
#' @export
#' @return A promoter annotation object with three slots: intronRanges, 
#'   promoterIdMapping and promoter Coordinates
#'   
#' @examples 
#' 
#' promoterAnnotation <- PromoterAnnotation()
#' intronRanges(promoterAnnotation) <- intronRanges(
#'                                     promoterAnnotation.gencode.v34.subset)
#' promoterIdMapping(promoterAnnotation) <- promoterIdMapping(
#'                                     promoterAnnotation.gencode.v34.subset)
#' promoterCoordinates(promoterAnnotation) <- promoterCoordinates(
#'                                     promoterAnnotation.gencode.v34.subset)
#' 

PromoterAnnotation <-
    function(intronRanges = GenomicRanges::GRanges(),
        promoterIdMapping = data.frame(),
        promoterCoordinates = GenomicRanges::GRanges()) {
    new(
        "PromoterAnnotation",
        intronRanges = intronRanges,
        promoterIdMapping = promoterIdMapping,
        promoterCoordinates = promoterCoordinates
    )
}

setValidity("PromoterAnnotation", function(object) {
    check <- TRUE
    if (is(object@intronRanges, 'GRanges') == FALSE) {
        check <- FALSE
    }
    if (is(object@promoterIdMapping, 'data.frame') == FALSE) {
        check <- FALSE
    }
    if (is(object@promoterCoordinates, 'GRanges') == FALSE) {
        check <- FALSE
    }
    return(check)
})

###############
### Getters ###

#' @param x A PromoterAnnotation object
#'
#' @describeIn PromoterAnnotation-class Getter for intronRanges
#' @exportMethod intronRanges

setGeneric("intronRanges", function(x) standardGeneric("intronRanges"))

#' @describeIn PromoterAnnotation-class Getter for intronRanges
#' @aliases intronRanges,PromoterAnnotation-method

setMethod("intronRanges", "PromoterAnnotation", function(x) x@intronRanges)

#' @describeIn PromoterAnnotation-class Getter for promoterIdMapping
#' @exportMethod promoterIdMapping

setGeneric("promoterIdMapping", 
            function(x) standardGeneric("promoterIdMapping"))

#' @describeIn PromoterAnnotation-class Getter for promoterIdMapping
#' @aliases promoterIdMapping,PromoterAnnotation-method

setMethod("promoterIdMapping", "PromoterAnnotation", 
            function(x) x@promoterIdMapping)

#' @describeIn PromoterAnnotation-class Getter for promoterCoordinates
#' @exportMethod promoterCoordinates

setGeneric("promoterCoordinates", 
            function(x) standardGeneric("promoterCoordinates"))

#' @describeIn PromoterAnnotation-class Getter for promoterCoordinates
#' @aliases promoterCoordinates,PromoterAnnotation-method

setMethod("promoterCoordinates", "PromoterAnnotation", 
            function(x) x@promoterCoordinates)

###############
### Setters ###

#' @param value intronRanges, promoterIdMapping or promoterCoordinates to 
#'   be assigned
#' 
#' @describeIn PromoterAnnotation-class Setter for intronRanges
#' @exportMethod 'intronRanges<-'
#' @importFrom methods validObject

setGeneric("intronRanges<-", 
            function(x, value) standardGeneric("intronRanges<-"))

#' @describeIn PromoterAnnotation-class Setter for intronRanges
#' @aliases 'intronRanges<-',PromoterAnnotation-method

setMethod("intronRanges<-", "PromoterAnnotation", function(x, value) {
    x@intronRanges <- value
    validObject(x)
    x
})

#' @describeIn PromoterAnnotation-class Setter for promoterIdMapping
#' @exportMethod 'promoterIdMapping<-'
#' @importFrom methods validObject

setGeneric("promoterIdMapping<-", 
            function(x, value) standardGeneric("promoterIdMapping<-"))

#' @describeIn PromoterAnnotation-class Setter for promoterIdMapping
#' @aliases 'promoterIdMapping<-',PromoterAnnotation-method

setMethod("promoterIdMapping<-", "PromoterAnnotation", function(x, value) {
    x@promoterIdMapping <- value
    validObject(x)
    x
})

#' @describeIn PromoterAnnotation-class Setter for promoterCoordinates
#' @exportMethod 'promoterCoordinates<-'
#' @importFrom methods validObject

setGeneric("promoterCoordinates<-", 
            function(x, value) standardGeneric("promoterCoordinates<-"))

#' @describeIn PromoterAnnotation-class Setter for promoterCoordinates
#' @aliases 'promoterCoordinates<-',PromoterAnnotation-method

setMethod("promoterCoordinates<-", "PromoterAnnotation", function(x, value) {
    x@promoterCoordinates <- value
    validObject(x)
    x
})

#' Estimates promoter counts and activity in a single command
#'
#' @param files A character vector. The list of input files for 
#'   which the junction read counts will be calculated
#' @param promoterAnnotation A PromoterAnnotation object containing the
#'   intron ranges, promoter coordinates and the promoter id mapping
#' @param fileLabels A character vector. The labels of input files 
#'   for which the junction read counts will be calculated. These labels will be 
#'   used as column names for each output data.frame object. If not provided,
#'   filenames will be used as labels. Defaults to NULL
#' @param condition A character vector. The condition to which each sample
#'   belong to. Must correspond to the order of the files. If supplied, 
#'   results are summarized by condition. Defaults to NULL
#' @param genome A character. Genome version. Must be specified if input file
#'   type is a BAM file. Defaults to NULL
#' @param ncores A numeric value. The number of cores to be used for 
#'   counting junction reads. Defaults to 1 (no parallelization). This parameter 
#'   will be used as an argument to BiocParallel::bplapply
#' 
#'
#' @export
#' @return A SummarizedExperiment object with assays giving promoter counts 
#'   and activity with gene expression. rowData contains
#'   promoter metadata and absolute promoter activity summarized across
#'   conditions (if condition is provided)
#' 
#' @examples
#' 
#' files <- list.files(system.file('extdata/vignette/junctions', 
#'                        package = 'proActiv'), 
#'                        full.names = TRUE, pattern = 'replicate5')
#' promoterAnnotation <- promoterAnnotation.gencode.v34.subset
#' result <- proActiv(files = files,
#'                        promoterAnnotation  = promoterAnnotation,
#'                        condition = rep(c('A549', 'HepG2'), each=1),
#'                        fileLabels = NULL,
#'                        ncores = 1)
#'                            
proActiv <- function(files, promoterAnnotation, fileLabels = NULL, 
                    condition = NULL, genome = NULL, ncores = 1) {
    
    parser <- parseFile(files, fileLabels, genome)
    fileLabels <- parser$fileLabels
    fileType <- parser$fileType
    
    result <- buildSummarizedExperiment(promoterAnnotation, files, fileLabels,
                                        fileType, genome, ncores)
    
    if (!is.null(condition)) {
        if (length(condition) != length(files)) {
            warning('Condition argument is invalid. 
                Please ensure a 1-1 map between each condition and each file.
                Returning results not summarized across conditions.')
            return(result)
        } else {
            result <- summarizeAcrossCondition(result, condition) 
        }
    }
    return(result) 
}

#' Integrate multiple proActiv runs 
#'
#' @param res1 A summarizedExperiment object returned by proActiv
#' @param res2 A summarizedExperiment object returned by proActiv
#' @param ... Additional summarizedExperiment objects returned by proActiv
#' @param promoterAnnotation Promoter annotation object used to create 
#'   proActiv runs
#' @param renormalize Whether to renormalize counts after merging. Defaults to 
#'   TRUE
#'
#' @export
#' @return A SummarizedExperiment object with assays giving promoter counts 
#'   and activity with gene expression. rowData contains
#'   promoter metadata and absolute promoter activity summarized across
#'   conditions (if condition is provided)
#' 
#' @examples
#' f1 <- list.files(system.file('extdata/vignette/junctions', 
#'                              package = 'proActiv'), 
#'                  full.names = TRUE, pattern = 'A549')
#' f2 <- list.files(system.file('extdata/vignette/junctions', 
#'                              package = 'proActiv'), 
#'                  full.names = TRUE, pattern = 'HepG2')
#' promoterAnnotation <- promoterAnnotation.gencode.v34.subset
#' res1 <- proActiv(files = f1, promoterAnnotation  = promoterAnnotation,
#'                  condition = rep('A549',3))
#' res2 <- proActiv(files = f2, promoterAnnotation = promoterAnnotation,
#'                  condition = rep('HepG2',3))
#' res <- integrateProactiv(res1, res2, promoterAnnotation = promoterAnnotation)
#'
#' @importFrom SummarizedExperiment assays `assays<-` cbind rowData `rowData<-`
integrateProactiv <- function(res1, res2, ..., 
                              promoterAnnotation,
                              renormalize = TRUE) {
    combined <- cbind(res1, res2, ...)
    if (renormalize) {
        promoterCounts <- assays(combined)$promoterCounts
        normalizedPromoterCounts <- normalizePromoterReadCounts(promoterCounts)
        absolutePromoterActivity <- getAbsolutePromoterActivity(
            normalizedPromoterCounts, promoterAnnotation)
        
        geneExpression <- getGeneExpression(absolutePromoterActivity)
        relativePromoterActivity <- getRelativePromoterActivity(
            absolutePromoterActivity, geneExpression)
        
        rownames(geneExpression) <- rownames(promoterCounts)
        fileLabels <- combined$sampleName
        assays(combined) <- list(promoterCounts = promoterCounts, 
            normalizedPromoterCounts = normalizedPromoterCounts, 
            absolutePromoterActivity = absolutePromoterActivity[, fileLabels, 
                                                                drop=FALSE], 
            relativePromoterActivity = relativePromoterActivity[, fileLabels, 
                                                                drop=FALSE],
            geneExpression = geneExpression[, fileLabels, drop=FALSE])    
        
        ## Settle rowData
        rowData(combined) <- rowData(combined)[-grep("mean|class", 
                                                colnames(rowData(combined)))]
        combined <- summarizeAcrossCondition(combined, combined$condition)
    }
    return(combined)
} 



# Helper function to impute file labels and infer file type
parseFile <- function(files, fileLabels, genome) {
    checkFile <- file.exists(files)
    if (any(!checkFile)) {
        stop(paste0('Error: Please specify valid file paths. 
                    The following file does not exist: ', files[!checkFile]))
    }
    
    if (is.null(fileLabels)) {
        fileLabels <- make.names(tools::file_path_sans_ext(basename(files), 
                                                            compression = TRUE),
                                unique = TRUE)
    }
    
    ext <- unique(tools::file_ext(files))
    if (length(ext) != 1) {
        stop("Error: More than one file type detected from given file path")
    }
    
    if (ext == 'gz' | ext == 'bz2' | ext == 'xz'){
        files.tmp <- gsub(paste0('\\.', ext), '', files)
        ext <- unique(tools::file_ext(files.tmp))
    }
    
    if (ext == 'bam') {
        fileType <- 'bam'
        if (is.null(genome)) {
            stop('Error: Please specify genome.')
        }
    } else if (ext == 'bed') {
        fileType <- 'tophat' 
    } else if (ext == 'junctions' | ext == 'tab') {
        fileType <- 'star'
    } else {
        stop('Invalid input files: Input must either be a BAM file (.bam), 
            Tophat junctions file (.bed) or 
            STAR junctions file (.junctions / .tab)')
    }
    parsed <- list(fileLabels = fileLabels, fileType = fileType) 
    return(parsed)
}

# Call functions to get activity and build summarized experiment
#' @importFrom SummarizedExperiment SummarizedExperiment 'rowData<-'
#' @importFrom data.table as.data.table .N ':='
#' @importFrom rlang .data
#' @importFrom S4Vectors 'metadata<-'
buildSummarizedExperiment <- function(promoterAnnotation, 
                                        files, fileLabels, fileType, 
                                        genome, ncores) {
    promoterCounts <- calculatePromoterReadCounts(promoterAnnotation, 
                                                    files, fileLabels, fileType, 
                                                    genome, ncores)
    normalizedPromoterCounts <- normalizePromoterReadCounts(promoterCounts)
    absolutePromoterActivity <- getAbsolutePromoterActivity(
                                                    normalizedPromoterCounts, 
                                                    promoterAnnotation)
    geneExpression <- getGeneExpression(absolutePromoterActivity)
    relativePromoterActivity <- getRelativePromoterActivity(
                                                    absolutePromoterActivity, 
                                                    geneExpression)
    result <- SummarizedExperiment(assays = list(
            promoterCounts = promoterCounts,
            normalizedPromoterCounts = normalizedPromoterCounts,
            absolutePromoterActivity = absolutePromoterActivity[, 
                                                    fileLabels, drop = FALSE],
            relativePromoterActivity = relativePromoterActivity[, 
                                                    fileLabels, drop = FALSE],
            geneExpression = geneExpression[, fileLabels, drop = FALSE]))
    
    message('Calculating positions of promoters...')
    promoterCoordinates <- promoterCoordinates(promoterAnnotation)
    promoterIdMapping <- promoterIdMapping(promoterAnnotation)
    promoterCoordinates$geneId <- promoterIdMapping$geneId[match(
                promoterCoordinates$promoterId, promoterIdMapping$promoterId)]
    promoterCoordinates <- as.data.table(promoterCoordinates)
    promoterPosition <- geneId <- strand <- NULL
    promoterCoordinates[, promoterPosition := ifelse(strand == '+', seq_len(.N), 
                                                rev(seq_len(.N))), by=geneId]
    ## Build row data
    rowData(result) <- data.frame(
                        absolutePromoterActivity[,c('promoterId', 'geneId')], 
                        promoterCoordinates[,c("seqnames","start", "strand",
                                    "internalPromoter", "promoterPosition")])
    transcriptByPromoter <- split(promoterIdMapping$transcriptName, 
                                promoterIdMapping$promoterId)
    rowData(result)$txId <- transcriptByPromoter[match(rowData(result)$promoterId, 
                                                names(transcriptByPromoter))]
    return(result)
}


# Helper function to summarize results across condition
#' @importFrom S4Vectors DataFrame metadata
#' @importFrom SummarizedExperiment rowData colData 'colData<-' assays
summarizeAcrossCondition <- function(result, condition) {
        if (any(make.names(condition) != condition)) {
            warning("Condition is modified to be syntactically valid")
            condition <- make.names(condition)
        }
        colData(result) <- DataFrame(sampleName = colnames(result), 
                                    condition=condition)
        colnames(result) <- colData(result)$sampleName
        message('Summarising expression and activity across conditions...')
        for (group in unique(condition)) {
            rowData(result)[,paste0(group, '.mean')] <- 
                rowMeans(assays(result[,colData(result)$condition==group])$abs) 
            rowData(result)[,paste0(group, '.gene.mean')] <- 
                rowMeans(assays(result[,colData(result)$condition==group])$gene)
        }
        rowData(result) <- categorizePromoters(rowData(result), condition)
    return(result)
}

# Helper function to categorize promoters
#' @importFrom rlang .data
#' @importFrom dplyr as_tibble '%>%' slice_max
categorizePromoters <- function(rdata, condition) {
    rdata <- as_tibble(rdata)
    for (group in unique(condition)) {
        message(paste0('Categorizing ', group, ' promoters...'))
        mean <- paste0(group, '.mean')
        class <- paste0(group, '.class')
        
        max_rows <- rdata %>%
            group_by(.data$geneId) %>%
            slice_max(!!as.name(mean), with_ties = FALSE)
        rdata[[class]] <- ifelse(rdata[[mean]] < 0.25, 'Inactive', 'Minor')
        rdata[[class]][match(max_rows$promoterId, rdata$promoterId)] <- "Major"
        rdata[[class]][which(rdata[[mean]] < 0.25)] <- "Inactive"
        rdata[[class]][which(rdata$internalPromoter)] <- NA
        rdata[[class]][which(is.na(rdata$internalPromoter))] <- NA
    }
    return(rdata)
}

context('proActiv Wrapper')
library(proActiv)

promoterAnnotation <- promoterAnnotation.gencode.v34.subset

test_that('proActiv handles non-existent files',{
  
  expect_error(proActiv('', promoterAnnotation))

  })

test_that('proActiv expects genome argument with BAM input', {
  
  bam <- list.files(system.file('extdata/testdata/bam', package = 'proActiv'),
                         full.names = TRUE)
  expect_error(proActiv(bam, promoterAnnotation))
  
})

test_that('proActiv handles invalid condition argument', {
  
  files <- list.files(system.file('extdata/vignette/junctions', package = 'proActiv'), 
                      full.names = TRUE, pattern = 'replicate5')
  expect_warning(proActiv(files = files, 
                           promoterAnnotation = promoterAnnotation,
                           condition = c('A549', 'HepG2', 'MCF7')))
  
})

test_that('proActiv returns a Summarized Experiment with junction input', {

  ## Test junction file input ###
  junctions <- list.files(system.file('extdata/vignette/junctions', package = 'proActiv'), full.names = TRUE)
  expect_s4_class(proActiv(junctions, promoterAnnotation), 'SummarizedExperiment')
  expect_s4_class(proActiv(junctions, promoterAnnotation, condition = rep(c('A549', 'HepG2'), each=3)), 'SummarizedExperiment')
  
  result <- proActiv(junctions, promoterAnnotation, condition = rep(c('A549', 'HepG2'), each=3))  
  expect_equal(length(assays(result)), 5)
  expect_equal(ncol(rowData(result)), 14)
  
})

# test_that('proActiv returns a Summarized Experiment with bam input', {
#   
#   ## Test BAM file input
#   bams <- list.files(system.file('extdata/testdata/bam', package = 'proActiv'), full.names = TRUE)
#   suppressWarnings(
#       expect_s4_class(proActiv(bams, promoterAnnotation, genome = 'hg38'), 'SummarizedExperiment')
#   )
#   suppressWarnings(
#       result <- proActiv(bams, promoterAnnotation, genome = 'hg38')
#   )
#   expect_equal(length(assays(result)), 4)
#   expect_equal(ncol(rowData(result)), 8)
#   
# })


test_that('proActiv parallelisation returns expected output', {
  
  junctions <- list.files(system.file('extdata/vignette/junctions', package = 'proActiv'), full.names = TRUE)
  ## Windows OS throws warnings
  suppressWarnings(
      expect_identical(proActiv(junctions, promoterAnnotation, ncores = 2), proActiv(junctions, promoterAnnotation, ncores = 1))
  )
  
})

#' @title Promoter annotation for Gencode.v34 (subset) 
#' @description Promoter annotation for Gencode.v34 
#'   (chr1:10,000,000 - 30,000,000) 
#' @format A PromoterAnnotation (S4 Class) object containing all promoter
#'   annotation objects for Gencode.v34 chr1:10,000,000-30,000,000. 
#'   The object has 3 slots: \describe{
#'   \item{intronRanges}{A GRanges object of 4,523 ranges corresponding
#'   to introns, annotated with the associated transcript.} 
#'   \item{promoterIdMapping}{The id mapping between transcript names, 
#'   promoter ids and gene ids for Gencode v34.} 
#'   \item{promoterCoordinates}{A GRanges object of 1,380 ranges
#'   showing the tss coordinate for each promoter of Gencode v34 
#'   chr1:10,000,000-30,000,000, annotated with the associated gene id, 
#'   coordinate of the 3' end of the first reduced exon, and intron id.} }
#'
"promoterAnnotation.gencode.v34.subset"

#' Visualizes promoter activity and gene expression with boxplots
#'
#' @param result A SummarizedExperiment object return by proActiv, with assays 
#'   giving promoter counts and activity with gene expression stored as 
#'   metadata. rowData contains promoter metadata and absolute promoter 
#'   activity summarized across conditions. Condition must be provided. 
#' @param geneId A character vector. A single gene id. This identifier must
#'   correspond to the identifier in the promoter annotation. 
#' @param geneName A character vector. Common gene name to be displayed
#'   on plot. Optional. Defaults to NULL.
#' @param filterInternal A boolean. Determines if internal promoters should be 
#'   removed from the plot. Defaults to TRUE. 
#' @param col A character vector of colours to be used for plotting. 
#' 
#' @export
#' @return A list of length 3. Each entry is a plot corresponding to 
#'  absolute promoter activity, relative promoter activity and gene expression.
#' 
#' @examples
#' files <- list.files(system.file('extdata/vignette/junctions', 
#'                        package = 'proActiv'), 
#'                        full.names = TRUE, pattern = 'replicate5')
#' promoterAnnotation <- promoterAnnotation.gencode.v34.subset
#' result <- proActiv(files = files,
#'                        promoterAnnotation  = promoterAnnotation,
#'                        condition = rep(c('A549', 'HepG2'), each=1),
#'                        fileLabels = NULL,
#'                        ncores = 1)
#' plots <- boxplotPromoters(result, "ENSG00000076864.19")
#' 
#' @importFrom SummarizedExperiment rowData
#' @importFrom S4Vectors metadata 
boxplotPromoters <- function(result, 
                                geneId, 
                                geneName = NULL, 
                                filterInternal = TRUE,
                                col = NULL) {
    
    rdata <- rowData(result)
    gexp <- as.matrix(assays(result)$gene)
    gexp <- gexp[, result$sampleName]
    rownames(gexp) <- rdata$geneId
    gexp <- gexp[!duplicated(gexp), ]
    gexp <- data.frame(gexp)
    genelst <- rdata$geneId
    
    geneIdx <- grep(geneId, genelst)
    if (length(geneIdx) == 0) {
        stop("Gene not found")
    }
    result <- result[geneIdx,]
    internalId <- TRUE
    if (filterInternal) {
        rdata <- rowData(result)
        internalId <- rdata$internalPromoter == FALSE
    }
    assay.abs <- assays(result)$abs[internalId,]
    assay.rel <- assays(result)$rel[internalId,]
    nonzero <- apply(assay.abs, 1, function(x) !all(x==0))
    assay.abs <- assay.abs[nonzero,,drop=FALSE]
    assay.rel <- assay.rel[nonzero,,drop=FALSE]
    gexp <- gexp[grep(geneId, rownames(gexp)),,drop=FALSE]
    if (nrow(assay.abs) == 0) {
        stop("Gene has no expressed non-internal promoters")
    }
    
    condition <- result$condition
    
    plot.abs <- generateBoxplot(assay.abs, condition, 
                                main = paste0("Absolute Promoter Activity ", 
                                                geneName),
                                col = col)
    plot.rel <- generateBoxplot(assay.rel, condition, 
                                main = paste0("Relative Promoter Activity ", 
                                                geneName),
                                col = col)
    plot.gexp <- generateBoxplot(gexp, condition, 
                                main = paste0("Gene Expression ", geneName), 
                                promoter = FALSE,
                                col = col)
    return(list(plot.abs, plot.rel, plot.gexp))
}

# Helper function for boxplotPromoters.
#' @importFrom data.table data.table melt
#' @importFrom ggplot2 ggplot geom_boxplot theme_light theme ggtitle aes 
#'   element_text scale_fill_manual
generateBoxplot <- function(data, 
                            condition, 
                            main, 
                            promoter = TRUE,
                            col) {
    ## Reshape to long for ggplot
    colnames(data) <- condition
    data$Feature <- rownames(data)
    data <- data.table(data)
    data <- melt(data, ncol(data))
    if (promoter) {
        data$Feature <- paste0('prmtr.', data$Feature)
    }
    names(data) <- c("Prmtr", "Condition", "Expression")
    data$Condition <- factor(data$Condition)
    
    Prmtr <- Expression <- Condition <- NULL
    ## Promoter and gene expression plots
    if (promoter) {
        outPlot <- ggplot(data = data, aes(x = Prmtr, y = Expression, fill = Condition)) + 
            geom_boxplot(outlier.alpha = 0.5, outlier.size = 1) + 
            theme_light() +
            theme(axis.text.x = element_text(angle = 90, vjust = 0.5, hjust = 1)) + 
            ggtitle(main)
    } else {
        outPlot <- ggplot(data = data, aes(x = Prmtr, y = Expression, fill = Condition)) + 
            geom_boxplot(outlier.alpha = 0.5, outlier.size = 1) + 
            theme_light() +
            ggtitle(main)
    }
    if (!is.null(col)) {
        outPlot <- outPlot + 
            scale_fill_manual(values = col[seq_len(length(unique(condition)))])
    }
    return(outPlot)
}



#' Performs principal component analysis 
#'
#' @param result A SummarizedExperiment object return by proActiv, with assays 
#'   giving promoter counts and activity with gene expression stored as 
#'   metadata. rowData contains promoter metadata and absolute promoter 
#'   activity summarized across conditions. Condition must be provided. 
#' @param by A character vector. The assay to perform principal component 
#'  analysis by. One of promoterCounts, normalizedPromoterCounts, 
#'  absolutePromoterActivity and geneExpression (unambiguous substrings can be 
#'  supplied). Defaults to absolutePromoterActivity.  
#' @param main A character vector. Plot title (optional). Defaults to NULL.
#' @param col A vector of colours. If NULL, uses standard ggplot colours. 
#'  Defaults to NULL.
#' @param alpha A numeric value in between 0 and 1. Determines point 
#'  transparency.
#' @param cex.size A numeric value. Determines point size. 
#' 
#' @export
#' @return PCA plot.
#' 
#' @examples
#' files <- list.files(system.file('extdata/vignette/junctions', 
#'                        package = 'proActiv'), 
#'                        full.names = TRUE, pattern = 'replicate5')
#' promoterAnnotation <- promoterAnnotation.gencode.v34.subset
#' result <- proActiv(files = files,
#'                        promoterAnnotation  = promoterAnnotation,
#'                        condition = rep(c('A549', 'HepG2'), each=1),
#'                        fileLabels = NULL,
#'                        ncores = 1)
#' result <- result[complete.cases(assays(result)[[1]]),]
#' plotPCA(result)
#' 
#' @importFrom ggplot2 ggplot geom_point theme_light ggtitle scale_color_manual
#'   xlab ylab xlim ylim
#' @importFrom stats prcomp
#' @importFrom SummarizedExperiment assays
plotPCA <- function(result, by = "absolutePromoterActivity",
                    main = NULL, col = NULL,
                    alpha = 0.75, cex.size = 2) {
    all <- c("promoterCounts", 
             "normalizedPromoterCounts",
             "absolutePromoterActivity",
             "geneExpression")
    assayIndex <- pmatch(by, all)
    assayIndex <- ifelse(assayIndex == 4, 5, assayIndex)
    if (is.na(assayIndex)) stop("Invalid assay.")
    message(paste0("Using assay ", names(assays(result))[assayIndex]))
    assay <- as.matrix(assays(result)[[assayIndex]])
    if (assayIndex == 5) {
        ## Remove duplicates for gene expression assay
        assay <- assay[!duplicated(rowData(result)$geneId),]
    }
    pca <- prcomp(t(assay))
    vv <- pca$sdev^2
    vv <- paste0(round(vv / sum(vv) * 100,2),"%")
    vv <- paste0("PC", seq_len(length(vv)), ": ", vv)
    pdata <- data.frame(PC1 = pca$x[,1], 
                        PC2 = pca$x[,2],
                        Condition = result$condition)
    
    lims <- max(abs(range(pca$x[,1])), abs(range(pca$x[,2]))) * c(-1,1)
    PC1 <- PC2 <- Condition <- NULL
    plot <- ggplot(pdata, aes(x = PC1, y = PC2)) + 
        geom_point(aes(color = Condition), alpha = alpha, size = cex.size) + 
        xlab(vv[1]) + ylab(vv[2]) + theme_light() + xlim(lims) + ylim(lims) 
    if (!is.null(main)) plot <- plot + ggtitle(main) 
    if (!is.null(col)) {
        nCond <- length(unique(result$condition))
        if (length(col) < nCond) {
            stop("Need as many colours as conditions.")
        }
        plot <- plot + scale_color_manual(values = col[seq_len(nCond)])
    }
    plot
}

#' Visualizes heatmap of features for samples
#'
#' @param result A SummarizedExperiment object return by proActiv, with assays 
#'   giving promoter counts and activity with gene expression stored as 
#'   metadata. rowData contains promoter metadata and absolute promoter 
#'   activity summarized across conditions. Condition must be provided.
#' @param by A character vector. The assay to visualize the heatmap for. 
#'   One of promoterCounts, normalizedPromoterCounts, 
#'   absolutePromoterActivity and geneExpression (unambiguous substrings can be 
#'   supplied). Defaults to absolutePromoterActivity.  
#' @param features Features to visualize. Either a list of promoterIds or 
#'   geneIds. The features must correspond to the assay is used, i.e., if 
#'   promoter assays are used, features must be promoterIds, while if gene
#'   expression assay is used, features must be geneIds. Defaults to NULL 
#'   (visualizes all features of the assay).
#' @param cex.legend A numeric value. Legend size.
#' @param cex.row A numeric value. Row label size.
#' @param cex.col A numeric value. Column label size.
#' @param row.margin A numeric value. Row margins.
#' @param col.margin A numeric value. Column margins.
#' @param col A vector of colours. Length should correspond to number of 
#'   experimental conditions. Defaults to NULL.
#' @param breaks A numeric vector. Breaks for heatmap plotting.
#' @param palette A character vector. One of bluered, redblue, redgreen, 
#'   greenred. Defaults to bluered. 
#' 
#' @export
#' @return Displays heatmap.
#' 
#' @examples
#' files <- list.files(system.file('extdata/vignette/junctions', 
#'                        package = 'proActiv'), 
#'                        full.names = TRUE, pattern = 'replicate5')
#' promoterAnnotation <- promoterAnnotation.gencode.v34.subset
#' result <- proActiv(files = files,
#'                        promoterAnnotation  = promoterAnnotation,
#'                        condition = rep(c('A549', 'HepG2'), each=1),
#'                        fileLabels = NULL,
#'                        ncores = 1)
#' result <- result[complete.cases(assays(result)[[1]]),] 
#' plotHeatmap(result)
#' 
#' @importFrom gplots heatmap.2 redblue bluered redgreen greenred
#' @importFrom graphics legend
#' @importFrom SummarizedExperiment assays
#' @importFrom scales hue_pal 
#' @importFrom stats complete.cases quantile
plotHeatmap <- function(result, by = "absolutePromoterActivity", 
                        features = NULL, 
                        cex.legend = 0.75, cex.row = NULL, cex.col = NULL,
                        row.margin = 5, col.margin = 12,
                        col = NULL, breaks = NULL, palette = "bluered") {
    all <- c("promoterCounts", "normalizedPromoterCounts",
             "absolutePromoterActivity","geneExpression")
    assayIndex <- pmatch(by, all)
    assayIndex <- ifelse(assayIndex == 4, 5, assayIndex)
    if (is.na(assayIndex)) stop("Invalid assay.")
    message(paste0("Using assay ", names(assays(result))[assayIndex]))
    assay <- as.matrix(assays(result)[[assayIndex]])
    if (assayIndex == 5) {
        ## Remove duplicates for gene expression assay
        assay <- assay[!duplicated(rowData(result)$geneId),]
        rownames(assay) <- unique(rowData(result)$geneId)
    } else {
        rownames(assay) <- rowData(result)$promoterId
    }
    if (!is.null(features)) {
        assay <- assay[rownames(assay) %in% features, ]
        if (nrow(assay) == 0) {
            stop("Features are not found in chosen assay. Ensure promoter 
                 features are used with promoter assays and gene features used 
                 with gene expression assay.")
        }
    } else {
        message("Using all features.")
    }
    if (assayIndex < 5) rownames(assay) <- paste0("prmtr. ", rownames(assay))
    ## Map colours
    condition <- result$condition
    cond <- unique(condition)
    nCond <- length(cond)
    if (!is.null(col)) {
        if (length(col) < nCond) stop("Need as many colours as conditions.")
        cols <- col[seq_len(nCond)]
    } else {
        cols <- hue_pal()(nCond)
    }
    names(cols) <- cond
    ## Filter all rows equal to zero
    assay <- assay[rowSums(assay) > 0, ]
    assay <- t(scale(t(assay)))
    assay <- assay[complete.cases(assay),]
    ## Plot
    if (is.null(breaks)) {
        limit <- as.numeric(unlist(assay))
        lb <- as.numeric(quantile(limit, 0.05))
        ub <- as.numeric(quantile(limit, 0.95))
        breaks <- seq(lb, ub, length.out = 21)
    }
    pal <- get(palette, mode = "function")
    if (is.null(cex.row)) cex.row <- 0.2 + 1/log10(nrow(assay))
    if (is.null(cex.col)) cex.col <- 0.2 + 1/log10(ncol(assay))
    heatmap.2(assay, col = pal(length(breaks)-1), breaks = breaks, 
              trace = 'none', ColSideColors = cols[result$condition],
              margins = c(row.margin, col.margin),
              cexRow = cex.row, cexCol = cex.col)
    legend("topright", legend = cond, fill = cols, border=FALSE, bty="n", 
           cex = cex.legend)
}

#' Identifies alternative promoters.
#'
#' @param result A SummarizedExperiment object with assays giving promoter 
#'   counts, activity and gene expression (output from proActiv). rowData 
#'   contains promoter metadata and absolute promoter activity summarized 
#'   across conditions. Condition must be provided.
#' @param referenceCondition A character vector. The reference condition to be 
#'   compared. Samples corresponding to all other conditions will be compared 
#'   to this samples in this current condition.  
#' @param minAbs A numeric value. Minimum value for promoter to be active in 
#'   absolute terms. Defaults to 0.25.
#' @param minRel A numeric value. Minimum value for promoter to be active in 
#'   relative terms. Defaults to 0.05.
#' @param maxPval A numeric value. Adjusted p-value threshold for detecting 
#'   alternative promoters. Defaults to 0.05.
#' @param promoterFC A numeric value. Minimum fold change for a promoter in the
#'   current condition compared to all other conditions. Promoters must have at 
#'   least this magnitude of fold change for alternative usage.
#' @param geneFC A numeric value. Maximum fold change for gene expression. To
#'   identify alternative promoter usage independent of changes in gene 
#'   expression, limit the gene expression fold change.
#'
#' @export
#' @return A list of length 2. Each entry is a dataframe summarizing 
#'  up-regulated and down-regulated promoters and their corresponding genes, 
#'  if any.
#'  
#' @examples  
#' files <- list.files(system.file('extdata/vignette/junctions', 
#'                        package = 'proActiv'), 
#'                        full.names = TRUE, pattern = 'replicate5')
#' promoterAnnotation <- promoterAnnotation.gencode.v34.subset
#' result <- proActiv(files = files,
#'                        promoterAnnotation  = promoterAnnotation,
#'                        condition = rep(c('A549', 'HepG2'), each=1),
#'                        fileLabels = NULL,
#'                        ncores = 1)
#' alternativePromoters <- getAlternativePromoters(result, "A549")
#' 
#' @importFrom SummarizedExperiment rowData
getAlternativePromoters <- function(result, referenceCondition,
                                    minAbs = 0.25, minRel = 0.05,
                                    maxPval = 0.05,
                                    promoterFC = 2.0, geneFC = 1.5) {
    condition <- result$condition
    if (is.null(condition)) {
        stop("The input summarized experiment must contain sample condition. 
                Run proActiv with a condition vector.")
    }
    id <- which(condition == referenceCondition)
    if (length(id) == 0 ) {
        stop(paste0("Invalid input condition. Should correspond to one of: ",
                    paste(unique(condition), collapse = ' ')))
    }
    condition[id] <- referenceCondition
    condition[-id] <- 'other'
    condition <- relevel(as.factor(condition), ref = 'other')
    resultAbs <- fitPromoters(result, referenceCondition, 
                            type = "absolute", thres = minAbs)
    resultRel <- fitPromoters(result, referenceCondition,
                            type = "relative", thres = minRel)
    
    altPro <- rep(0, nrow(result))
    altPro[
        resultAbs$padj < maxPval & resultRel$padj < maxPval &
        resultAbs$abs.cond > (promoterFC * resultAbs$abs.other) & 
        resultAbs$abs.cond > minAbs &
        resultAbs$gexp.cond < (geneFC * resultAbs$gexp.other) & 
        resultAbs$gexp.cond > (resultAbs$gexp.other / geneFC)] <- 1
    altPro[
        resultAbs$padj < maxPval & resultRel$padj < maxPval &
        resultAbs$abs.other > (promoterFC * resultAbs$abs.cond) & 
        resultAbs$abs.other > minAbs &
        resultAbs$gexp.other < (geneFC * resultAbs$gexp.cond) & 
        resultAbs$gexp.other > (resultAbs$gexp.cond / geneFC)] <- -1
    
    rdata <- data.frame(rowData(result))
    upReg <- which(altPro > 0)
    upSet <- rdata[upReg,seq_len(2)]
    upSet <- cbind(upSet, padjAbs=resultAbs[upReg,"padj"], 
                   padjRel=resultRel[upReg, "padj"])
    downReg <- which(altPro < 0)
    downSet <- rdata[downReg,seq_len(2)]
    downSet <- cbind(downSet, padjAbs=resultAbs[downReg,"padj"], 
                   padjRel=resultRel[downReg, "padj"])
    if (length(upReg) == 0 && length(downReg) == 0) {
        message("No alternative promoters detected with current parameters. 
                Consider relaxing thresholds.")
    }
    return(list(upReg = upSet, downReg = downSet))
}

# Fits promoter activity to condition
#' @importFrom SummarizedExperiment assays rowData
#' @importFrom S4Vectors metadata
#' @importFrom stats lm p.adjust relevel
fitPromoters <- function(result, referenceCondition, type, thres) {
    if (type == "absolute") {
        raw.assay <- assays(result)$absolutePromoterActivity
    } else if (type == "relative") {
        raw.assay <- assays(result)$relativePromoterActivity
    }
    rdata <- rowData(result)
    condition <- result$condition
    nonInternalId <- which(rdata$internalPromoter == FALSE)
    pval <- rep(NaN, nrow(rdata))
    
    ## Regression - restrict to non-internal
    message(paste0("Fitting ", type, " promoter activity to condition..."))
    assay <- raw.assay[nonInternalId, ]
    num.pros <- nrow(assay)
    pval[nonInternalId] <- unlist(lapply(seq_len(num.pros), function(i) 
        tryCatch(summary(lm(unlist(assay[i,]) ~ condition))$coef[2,4], 
                warning = function(cond) 1,
                error = function(cond) NaN)))
    padj <- p.adjust(pval, method = "BH")
    
    ## Other metrics
    ## - mean absolute promoter activity each in group
    ## - gene expression
    id <- which(condition == referenceCondition)
    
    mean.cond <- rowMeans(raw.assay[,id, drop = FALSE], na.rm = TRUE) 
    mean.other <- rowMeans(raw.assay[,-id, drop = FALSE], na.rm = TRUE) 
    
    gexp <- assays(result)$gene
    gexp <- as.matrix(gexp[, result$sampleName])
    rownames(gexp) <- rowData(result)$geneId
    mean.gexp.cond <- rowMeans(gexp[,id, drop = FALSE], na.rm=TRUE)
    mean.gexp.cond <- mean.gexp.cond[match(rdata$geneId, rownames(gexp))]
    mean.gexp.other <- rowMeans(gexp[,-id, drop = FALSE], na.rm=TRUE)
    mean.gexp.other <- mean.gexp.other[match(rdata$geneId, rownames(gexp))]
    result <- data.frame(promoterId = rdata$promoterId,
                                    geneId = rdata$geneId,
                                    pval = pval,
                                    padj = padj,
                                    abs.cond = mean.cond,
                                    abs.other = mean.other,
                                    gexp.cond = mean.gexp.cond,
                                    gexp.other = mean.gexp.other)
    return(result)
}

#' Prepares promoter annotation from a gtf or txdb 
#'
#' @param txdb A txdb object. The txdb of the annotation version for which
#'   promoters will be identified. Either `txdb` or `file` argument must be 
#'   specified, but not both.
#' @param file A character object. The file path to a gtf/gff or txdb of the 
#'   annotation version for which promoters will be identified. Either `txdb` 
#'   or `file` argument must be specified, but not both.
#' @param species A character object. The genus and species of the organism to
#'   be used in keepStandardChromosomes(). Supported species can be seen with
#'   names(genomeStyles()).
#'
#' @return A PromoterAnnotation object. The annotated
#'   intron ranges, promoter coordinates and the promoter id mapping are
#'   attributes of the promoter annotation data.
#' @export
#'
#' @examples
#' 
#' txdbPath <- system.file('extdata/vignette/annotations/',
#'                             'gencode.v34.annotation.subset.sqlite', 
#'                              package = 'proActiv')
#' txdb <- AnnotationDbi::loadDb(txdbPath)
#' promoterAnnotation <- preparePromoterAnnotation(txdb = txdb,
#'                                                 species = 'Homo_sapiens')
#' 
#' @importFrom GenomicFeatures promoters 
#' @importFrom GenomicRanges width resize end
#' @importFrom S4Vectors 'mcols<-'
preparePromoterAnnotation <- function(txdb, file, species) {
    txdb <- parseTxdb(txdb, file, species)
    promoterAnnotation <- PromoterAnnotation()
    
    ### Reduce first exons to identify transcripts belonging to each promoter 
    message('Extract exons by transcripts...')
    transcriptRanges <- getTranscriptRanges(txdb, species) 
    exonRangesByTx <- getExonRangesByTx(txdb, species = species) 
    transcriptRanges$TxWidth <- vapply(width(exonRangesByTx), 
                                        FUN = sum, FUN.VALUE = numeric(1)) 
    
    ## Annotate first exons of each transcript 
    exonRangesByTx.unlist <- unlist(exonRangesByTx)
    exonRanges.firstExon <- getFirstExonRanges(exonRangesByTx.unlist)
    exonRanges.firstExon.geneId <- as.character(
        transcriptRanges$GENEID)[match(exonRanges.firstExon$tx_name, 
                                        transcriptRanges$TXNAME)]
    
    ## Identify overlapping first exons by gene and annotate with promoter ids
    message('Identify overlapping first exons for each gene...')
    exonReducedRanges <- getReducedExonRanges(exonRanges.firstExon, 
                                                exonRanges.firstExon.geneId)
    
    ### Prepare the id mapping transcripts, TSSs, promoters and genes ###
    message('Prepare mapping between transcripts, tss, promoters and genes...')
    tssCoordinates <- getTssRanges(transcriptRanges)
    revmapTMP <- as.vector(exonReducedRanges$revmap)
    txName.all <- exonRanges.firstExon$tx_name[unlist(revmapTMP)]
    promoterId.all <- rep(exonReducedRanges$promoterId, vapply(revmapTMP, 
                                                        FUN = length, 
                                                        FUN.VALUE = numeric(1)))
    txId.all <- transcriptRanges$TXID[match(txName.all, transcriptRanges$TXNAME)]
    tssId.all <- tssCoordinates$tssId[match(txName.all, tssCoordinates$TXNAME)]
    geneId.all <- as.character(transcriptRanges$GENEID)[match(txName.all, transcriptRanges$TXNAME)]
    promoterIdMapping <- data.frame(txId = txId.all,
                                    txName = txName.all,
                                    tssId = tssId.all,
                                    promoterId = promoterId.all,
                                    geneId = geneId.all,
                                    stringsAsFactors = FALSE)
    promoterIdMapping <- promoterIdMapping[match(seq_len(nrow(promoterIdMapping)), promoterIdMapping$txId), ]
    rownames(promoterIdMapping) <- NULL
    colnames(promoterIdMapping) <- c('transcriptId', 'transcriptName', 
                                        'tssId', 'promoterId', 'geneId')
    
    ### Prepare the annotated intron ranges to be used as input for junction read counting ###
    message('Prepare annotated intron ranges...')
    intronRangesByTx <- getIntronRangesByTx(txdb, transcriptRanges, species) 
    intronRangesByTx.unlist <- unlist(intronRangesByTx)
    intronRanges.unique <- getUniqueIntronRanges(intronRangesByTx.unlist) 
    
    ## Annotate full length intron ranges with intron id
    intronRanges.overlap <- findOverlaps(intronRangesByTx.unlist, 
                                        intronRanges.unique, type = 'equal')
    intronRangesByTx.unlist$INTRONID <- subjectHits(intronRanges.overlap)
    
    ## Extract ranks of introns for each transcript
    intronRankByTx <- getIntronRanks(intronRangesByTx)
    ## Annotate all intron ranges with corresponding ids
    intronRangesByTx.unlist <- annotateAllIntronRanges(intronRankByTx, 
                                                        intronRangesByTx.unlist, 
                                                        transcriptRanges, 
                                                        promoterIdMapping)
    
    ## Annotate unique intron ranges with corresponding ids
    intronRanges.unique <- annotateUniqueIntronRanges(intronRanges.unique, intronRangesByTx.unlist)
    intronTable <- getIntronTable(intronRanges.unique, intronRangesByTx.unlist)
    intronRanges.annotated <- annotateIntronRanges(intronRanges.unique, intronTable)
    
    ### Annotate the reduced exons with promoter metadata
    message('Annotating reduced exon ranges...')
    ## Identify first intron for each promoter for each transcript 
    intronIdByPromoter.firstIntron <- getIntronIdPerPromoter(intronRangesByTx.unlist, promoterIdMapping)
    
    ## Retrieve first intron ranges
    intronRanges.firstIntron <- intronRangesByTx.unlist[intronRangesByTx.unlist$INTRONRANK == 1]
    intronTable.firstIntron <- intronTable[match(intronRanges.firstIntron$INTRONID, intronTable$INTRONID), ]
    intronTable.firstIntron$promoterId <- intronRanges.firstIntron$promoterId
    
    promoterMetadata <- getPromoterMetadata(intronTable.firstIntron)
    exonReducedRanges <- annotateReducedExonRanges(exonReducedRanges, promoterMetadata, intronIdByPromoter.firstIntron)
    
    ### Retrieve promoter coordinates
    message('Prepare promoter coordinates and first exon ranges...')
    promoterCoordinates <- promoters(exonReducedRanges, downstream = 1, upstream = 0)
    exonEnd <- resize(exonReducedRanges, width = 1, fix = 'end')
    promoterCoordinates.metadata <- data.frame(promoterId = promoterCoordinates$promoterId,
                                                geneId = promoterIdMapping$geneId[match(promoterCoordinates$promoterId, promoterIdMapping$promoterId)],
                                                internalPromoter = promoterCoordinates$MaxMergedIntronRank > 1,
                                                firstExonEnd = end(exonEnd),
                                                stringsAsFactors = FALSE)
    mcols(promoterCoordinates) <- promoterCoordinates.metadata
    promoterCoordinates$intronId <- exonReducedRanges$intronId
    
    ### Build Promoter Annotation
    intronRanges(promoterAnnotation) <- intronRanges.annotated[,c('INTRONID', 'TXNAME')]
    promoterIdMapping(promoterAnnotation) <- promoterIdMapping[,c('transcriptName', 'promoterId', 'geneId')]
    promoterCoordinates(promoterAnnotation) <- promoterCoordinates[,c('promoterId', 'internalPromoter', 'firstExonEnd', 'intronId')]
    return(promoterAnnotation)
} 

context('Calculating Promoter Annotation')
library(proActiv)

gtfPath <- system.file('extdata/vignette/annotations/gencode.v34.annotation.subset.gtf.gz', package = 'proActiv')
txdbPath <- system.file('extdata/vignette/annotations/gencode.v34.annotation.subset.sqlite', package = 'proActiv')

txdb <- AnnotationDbi::loadDb(txdbPath)

test_that('preparePromoterAnnotation handles ambiguous argument specification', {
  expect_error(preparePromoterAnnotation(gtfPath, 'Homo_sapiens'))
})


test_that('preparePromoterAnnotation handles non-existent files', {
  
  file <- 'sample.txt'
  expect_error(preparePromoterAnnotation(file = file, species = 'Homo_sapiens'))
  
})

test_that('preparePromoterAnnotation returns expected output with gtf file path',{
  
  ## Windows OS throws warnings
  suppressWarnings(
    promoterAnnotation <- preparePromoterAnnotation(file = gtfPath, species = 'Homo_sapiens')
  )
  expect_identical(promoterAnnotation.gencode.v34.subset, promoterAnnotation)
  expect_s4_class(intronRanges(promoterAnnotation), 'GRanges')
  expect_type(promoterIdMapping(promoterAnnotation), 'list')
  expect_s4_class(promoterCoordinates(promoterAnnotation), 'GRanges')
  
})

test_that('preparePromoterAnnotation returns expected output with txdb file path',{
  
  promoterAnnotation <- preparePromoterAnnotation(file = txdbPath, species = 'Homo_sapiens')
  expect_identical(promoterAnnotation.gencode.v34.subset, promoterAnnotation)
  expect_s4_class(intronRanges(promoterAnnotation), 'GRanges')
  expect_type(promoterIdMapping(promoterAnnotation), 'list')
  expect_s4_class(promoterCoordinates(promoterAnnotation), 'GRanges')
  
})

test_that('preparePromoterAnnotation returns expected output with txdb object', {
  
  promoterAnnotation <- preparePromoterAnnotation(txdb = txdb, species = 'Homo_sapiens')
  expect_identical(promoterAnnotation.gencode.v34.subset, promoterAnnotation)
  expect_s4_class(intronRanges(promoterAnnotation), 'GRanges')
  expect_type(promoterIdMapping(promoterAnnotation), 'list')
  expect_s4_class(promoterCoordinates(promoterAnnotation), 'GRanges')
  
})

## ----setup, include = FALSE---------------------------------------------------
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)

## ----QuickStart, eval=TRUE, message=FALSE, results='hide'---------------------
library(proActiv)

## List of STAR junction files as input
files <- list.files(system.file('extdata/vignette/junctions', 
                                package = 'proActiv'), full.names = TRUE)
## Vector describing experimental condition
condition <- rep(c('A549','HepG2'), each=3)
## Promoter annotation for human genome GENCODE v34 restricted to a subset of chr1
promoterAnnotation <- promoterAnnotation.gencode.v34.subset

result <- proActiv(files = files, 
                   promoterAnnotation = promoterAnnotation,
                   condition = condition)

## ----List files, eval=FALSE---------------------------------------------------
# files <- list.files(system.file('extdata/vignette/junctions',
#                                 package = 'proActiv'), full.names = TRUE)

## ----Create annotation, eval=FALSE--------------------------------------------
# ## From GTF file path
# gtf.file <- system.file('extdata/vignette/annotation/gencode.v34.annotation.subset.gtf.gz',
#                         package = 'proActiv')
# promoterAnnotation.gencode.v34.subset <- preparePromoterAnnotation(file = gtf.file,
#                                                                    species = 'Homo_sapiens')
# ## From TxDb object
# txdb.file <- system.file('extdata/vignette/annotation/gencode.v34.annotation.subset.sqlite',
#                          package = 'proActiv')
# txdb <- loadDb(txdb.file)
# promoterAnnotation.gencode.v34.subset <- preparePromoterAnnotation(txdb = txdb,
#                                                                    species = 'Homo_sapiens')

## ----Other species, eval=TRUE-------------------------------------------------
names(GenomeInfoDb::genomeStyles())

## ----proActiv, eval=FALSE, message=FALSE, results='hide'----------------------
# promoterAnnotation <- promoterAnnotation.gencode.v34.subset
# 
# condition <- rep(c('A549', 'HepG2'), each=3)
# 
# result <- proActiv(files = files,
#                    promoterAnnotation = promoterAnnotation,
#                    condition = condition)

## ----proActiv result, eval=TRUE-----------------------------------------------
show(result)

## ----Result rowData, eval=TRUE, echo=FALSE------------------------------------
knitr::kable(head(rowData(result)))

## ----Filter result, eval=TRUE-------------------------------------------------
## Removes single-exon transcripts / promoters by eliminating promoter counts that are NA 
result <- result[complete.cases(assays(result)$promoterCounts),]

## ----Get alternative, eval=TRUE-----------------------------------------------
alternativePromoters <- getAlternativePromoters(result = result, referenceCondition = "A549")
show(alternativePromoters)

## ----Boxplot, eval=TRUE, message=FALSE, fig.align='center', fig.height=5, fig.width=7----
plots <- boxplotPromoters(result, "ENSG00000076864.19")

# Boxplot of absolute promoter activity
library(gridExtra)
grid.arrange(plots[[1]], plots[[3]], nrow = 1, ncol = 2, widths = c(3, 2))

## ----VizPromoterCategories, eval=TRUE, fig.align='center', fig.height=5, fig.width=5, message=FALSE, warning=FALSE----
library(ggplot2)

rdata <- rowData(result)
## Create a long dataframe summarizing cell line and promoter class
pdata1 <- data.frame(cellLine = rep(c('A549', 'HepG2'), each = nrow(rdata)),
                       promoterClass = as.factor(c(rdata$A549.class, rdata$HepG2.class)))

ggplot(na.omit(pdata1)) +
  geom_bar(aes(x = cellLine, fill = promoterClass)) + 
  xlab('Cell Lines') + ylab('Count') +  labs(fill = 'Promoter Category') +
  ggtitle('Categorization of Promoters')

## ----VizMajorMinorPosition, eval=TRUE, fig.align='center', fig.height=5, fig.width=5, message=FALSE, warning=FALSE----
## Because many genes have many annotated promoters, we collapse promoters 
## from the 5th position and onward into one group for simplicity
pdata2 <- as_tibble(rdata) %>%
  mutate(promoterPosition = ifelse(promoterPosition > 5, 5, promoterPosition)) %>%
  filter(HepG2.class %in% c('Major', 'Minor'))

ggplot(pdata2) +
  geom_bar(aes(x = promoterPosition, fill = as.factor(HepG2.class)), position = 'fill') +
  xlab(expression(Promoter ~ Position ~ "5'" %->% "3'")) + ylab('Percentage') + 
  labs(fill = 'Promoter Category') + ggtitle('Major/Minor Promoter Proportion in HepG2') + 
  scale_y_continuous(breaks = seq(0,1, 0.25), labels = paste0(seq(0,100,25),'%')) +
  scale_x_continuous(breaks = seq(1,5), labels = c('1','2','3','4','>=5'))

## ----VizMajorGeneExp, eval=TRUE, fig.align='center', fig.height=5, fig.width=6.5, message=FALSE, warning=FALSE----
## Get active major promoters of HepG2
majorPromoter <- as_tibble(rdata) %>% group_by(geneId) %>% 
  mutate(promoterCount = n()) %>% filter(HepG2.class == 'Major') 

pdata3 <- data.frame(proActiv = majorPromoter$HepG2.mean,
                     geneExp = majorPromoter$HepG2.gene.mean,
                     promoterCount = majorPromoter$promoterCount)

ggplot(pdata3, aes(x = geneExp, y = proActiv)) + 
  geom_point(aes(colour = promoterCount), alpha = 0.5) +
  ggtitle('Major Promoter Activity vs. Gene Expression in HepG2') + 
  xlab('Average Gene Expression') + ylab('Average Major Promoter Activity') +
  labs(colour = 'Number of \n Annotated Promoters') +
  geom_abline(slope = 1, intercept = 0, colour = 'red', linetype = 'dashed')

## ----VizTsne, eval=TRUE, fig.align='center', fig.height=5.2, fig.width=5.2----
library(Rtsne)

## Remove inactive promoters (sparse rows)
data <- assays(result)$absolutePromoterActivity %>% filter(rowSums(.) > 0)
data <- data.frame(t(data))
data$Sample <- as.factor(condition)

set.seed(40) # for reproducibility

tsne.out <- Rtsne(as.matrix(subset(data, select = -c(Sample))), perplexity = 1)
plot(x = tsne.out$Y[,1], y = tsne.out$Y[,2], bg = data$Sample, asp = 1,
     col = 'black', pch = 24, cex = 4,
     main = 't-SNE plot with promoters \n active in at least one sample',
     xlab = 'T-SNE1', ylab = 'T-SNE2',
     xlim = c(-300,300), ylim = c(-300,300))
legend('topright', inset = .02, title = 'Cell Lines',
       unique(condition), pch = c(24,24), pt.bg = 1:length(unique(condition)) , cex = 1.5, bty = 'n')

## ----SessionInfo, eval=TRUE, echo=FALSE---------------------------------------
sessionInfo()

---
title: "Identifying Active and Alternative Promoters from RNA-Seq data with proActiv"
author:
  - name: Joseph Lee, Deniz Demircioğlu, Jonathan Göke 
output: rmarkdown::html_vignette
vignette: >
  %\VignetteIndexEntry{Identifying Active and Alternative Promoters from RNA-Seq data with proActiv}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r setup, include = FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)
```

## Summary

Most human genes have multiple promoters that control the expression of distinct isoforms. The use of these alternative promoters enables the regulation of isoform expression pre-transcriptionally. Alternative promoters have been found to be important in a wide number of cell types and diseases.

proActiv is a method that enables the analysis of promoters from RNA-Seq data. proActiv uses aligned reads as input, and then generates counts and normalized promoter activity estimates for each annotated promoter. These estimates can then be used to identify which promoter is active, which promoter is inactive, and which promoters change their activity across conditions.

Here we present a quick start guide to using proActiv, and a detailed workflow for identifying active promoters and alternative promoters across 2 conditions.

If you use proActiv in your research, please cite: 

[Demircioğlu, Deniz, et al. "A Pan-cancer Transcriptome Analysis Reveals Pervasive Regulation through Alternative Promoters." *Cell* 178.6 (2019): 1465-1477.](https://www.cell.com/cell/fulltext/S0092-8674(19)30906-7)

## Contents

- [Quick Start: Quantifying promoter activity with proActiv]
- [A complete workflow to identify alternative promoter usage]
  - [Preparing input data]
  - [Preparing promoter annotations]
  - [Running proActiv]
  - [Identifying alternative promoters]
- [Analysis and visualization of alternative promoter usage]
  - [Alternative promoter usage]
  - [Promoter category proportion]
  - [Major/minor promoters by position]
  - [Major promoter activity and gene expression]
  - [t-SNE]
- [Getting help]
- [Citing proActiv]
- [Session information]

## Quick Start: Quantifying promoter activity with proActiv

proActiv estimates promoter activity from RNA-Seq data. Promoter activity is defined as the total amount of transcription initiated at each promoter. proActiv takes as input either BAM files or junction files (TopHat2 or STAR), and a promoter annotation object of the relevant genome. An optional argument `condition` can be supplied, describing the condition corresponding to each input file. Here we demonstrate proActiv with STAR junction files (Human genome GRCh38 Gencode v34) as input. Due to size constraints, analysis is restricted to a subset of chr1 (10,000,000-30,000,000).

```{r QuickStart, eval=TRUE, message=FALSE, results='hide'}
library(proActiv)

## List of STAR junction files as input
files <- list.files(system.file('extdata/vignette/junctions', 
                                package = 'proActiv'), full.names = TRUE)
## Vector describing experimental condition
condition <- rep(c('A549','HepG2'), each=3)
## Promoter annotation for human genome GENCODE v34 restricted to a subset of chr1
promoterAnnotation <- promoterAnnotation.gencode.v34.subset

result <- proActiv(files = files, 
                   promoterAnnotation = promoterAnnotation,
                   condition = condition)
```

`result` is a summarizedExperiment object which can be accessed as follows:

 - `assays(results)` returns raw/normalized promoter counts, absolute/relative promoter activity and gene expression
 - `rowData(results)` returns promoter metadata and summarized absolute promoter activity and gene expression by conditions

## A complete workflow to identify alternative promoter usage

Here we present a complete step-by-step workflow for analyzing promoter activity with proActiv and for identifying alternative promoter usage across samples from different conditions. We will compare samples from 2 different cell lines (A549 and HepG2) to identify alternative promoters.

### Preparing input data

proActiv uses RNA-Seq data to quantify promoter activity. Users have the option of using as input either BAM files, or tab-delimited junction files that are generated when TopHat2 or STAR is used for read alignment.

Below, we demonstrate running `proActiv` with input STAR junction files. This data is taken from the [SGNEx project](https://github.com/GoekeLab/sg-nex-data), and restricted to the chr1:10,000,000-30,000,000 region. The reference genome used for alignment is Gencode v34 (GRCh38). These files can be found in `extdata/vignette/junctions`:

- `extdata/vignette/SGNEx_A549_Illumina_replicate1-run1.subset.SJ.out.tab.gz`
- `extdata/vignette/SGNEx_A549_Illumina_replicate3-run1.subset.SJ.out.tab.gz` 
- `extdata/vignette/SGNEx_A549_Illumina_replicate5-run1.subset.SJ.out.tab.gz`
- `extdata/vignette/SGNEx_HepG2_Illumina_replicate2-run1.subset.SJ.out.tab.gz` 
- `extdata/vignette/SGNEx_HepG2_Illumina_replicate4-run1.subset.SJ.out.tab.gz` 
- `extdata/vignette/SGNEx_HepG2_Illumina_replicate5-run1.subset.SJ.out.tab.gz`

```{r List files, eval=FALSE}
files <- list.files(system.file('extdata/vignette/junctions', 
                                package = 'proActiv'), full.names = TRUE)
```

### Preparing promoter annotations

In order to quantify promoter activity, proActiv uses a set of promoters based on genome annotations. proActiv allows the creation of a promoter annotation object for any genome from a TxDb object or from a GTF file with the `preparePromoterAnnotation` function. Users have the option to either pass the file path of the GTF/GFF or TxDb to be used, or use the TxDb object directly as input. proActiv includes pre-calculated promoter annotations for the human genome (GENCODE v34). However, due to size constraints, the annotation is restricted to the chr1:10,000,000-30,000,000 region. Users can build full annotations by downloading GTF files from [GENCODE](https://www.gencodegenes.org) page and following the steps below.

We demonstrate creating the restricted promoter annotation for the Human genome (GENCODE v34) with both GTF and TxDb:

```{r Create annotation, eval=FALSE}
## From GTF file path
gtf.file <- system.file('extdata/vignette/annotation/gencode.v34.annotation.subset.gtf.gz', 
                        package = 'proActiv')
promoterAnnotation.gencode.v34.subset <- preparePromoterAnnotation(file = gtf.file,
                                                                   species = 'Homo_sapiens')
## From TxDb object
txdb.file <- system.file('extdata/vignette/annotation/gencode.v34.annotation.subset.sqlite', 
                         package = 'proActiv')
txdb <- loadDb(txdb.file)
promoterAnnotation.gencode.v34.subset <- preparePromoterAnnotation(txdb = txdb, 
                                                                   species = 'Homo_sapiens')
```

The `PromoterAnnotation` object has 3 slots:
 
- `intronRanges` : Intron ranges, giving the corresponding transcripts of each intron
- `promoterIdMapping` : An ID mapping between transcripts, promoter IDs and gene IDs  
- `promoterCoordinates` : Promoter coordinates (TSS) and internal promoter state, along with the 3' coordinate of the first exon 

When creating promoter annotations for other species, one can call `genomeStyles` to identify 
the `species` argument to be used:
```{r Other species, eval=TRUE}
names(GenomeInfoDb::genomeStyles())
```

### Running proActiv

Once promoters in the genome are identified, proActiv estimates promoter activity at each annotated promoter. Here, we load pre-calculated promoter annotation for GENCODE Release 34. We also supply the experimental condition to `proActiv`. This information allows `proActiv` to summarize results across conditions.

```{r proActiv, eval=FALSE, message=FALSE, results='hide'}
promoterAnnotation <- promoterAnnotation.gencode.v34.subset

condition <- rep(c('A549', 'HepG2'), each=3)

result <- proActiv(files = files,
                   promoterAnnotation = promoterAnnotation,
                   condition = condition)
```

`result` is a `SummarizedExperiment` object with assays as raw/normalized promoter counts, absolute/relative promoter activity and gene expression: 

```{r proActiv result, eval=TRUE}
show(result)
``` 

The `rowData` slot stores a promoter-gene ID mapping and promoter position (5' to 3') for each promoter by gene. Mean absolute promoter activity and gene expression for each condition is also summarized here. Promoters are also categorized into three classes. Promoters with activity < 0.25 are classified as inactive, while the most active promoters of each gene are classified as major promoters. Promoters active at lower levels are classified as minor promoters. 

```{r Result rowData, eval=TRUE, echo=FALSE}
knitr::kable(head(rowData(result)))
```

For cleaner downstream analysis, one can remove single-exon transcripts for which promoter activity is not quantified. `result` can be filtered as such:

```{r Filter result, eval=TRUE}
## Removes single-exon transcripts / promoters by eliminating promoter counts that are NA 
result <- result[complete.cases(assays(result)$promoterCounts),]
```

### Identifying alternative promoters

To identify alternative promoter usage, proActiv implements a linear model, regressing both absolute promoter activity and relative promoter activity against sample conditions. A change in absolute promoter activity indicates absolute differential usage of the promoter. However, this does not imply alternative usage or a switch in major promoter, as the relative usage of promoters between conditions may still be the same. For this reason, information from relative promoter activity must also be taken into account. Alternative promoter usage is thus characterized by a significant change in absolute and relative promoter activity across conditions.

Candidates for alternative promoter usage can be identified by calling `getAlternativePromoters`. This function takes in the `result` object returned by `proActiv`, and `referenceCondition`, the reference condition to be compared to all other samples. 

```{r Get alternative, eval=TRUE}
alternativePromoters <- getAlternativePromoters(result = result, referenceCondition = "A549")
show(alternativePromoters)
```

Detection of alternative promoters with the following parameters:  

- `minAbs` Minimum value for promoter to be active in absolute terms. Defaults to 0.25.    
- `minRel` Minimum value for promoter to be active in relative terms. Defaults to 0.05.    
- `maxPval` Adjusted p-value threshold for detecting alternative promoters. Defaults to 0.05.    
- `promoterFC` Minimum fold change for a promoter in the current condition compared to all other conditions. Promoters must have at least this magnitude of fold change for alternative usage. This parameter can be decreased to relax alternative usage definition. Defaults to 2.0.    
- `geneFC` Maximum fold change for gene expression. To identify alternative promoter usage independent of changes in gene expression, limit the gene expression fold change. Promoters must have at most this magnitude of gene expression fold change for alternative usage. This parameter can be increased to relax alternative usage definition. Defaults to 1.5.  

## Analysis and visualization of alternative promoter usage

Here we offer several visualizations of the data returned by the workflow above.

### Alternative Promoter Usage

To visualize genes with alternative promoter usage across conditions, the function `boxplotPromoters` can be used. This function outputs boxplots of gene expression, absolute and relative promoter activity for a gene of interest. `boxplotPromoters` takes the following arguments:  

- `result`. The `summarizedExperiment` object returned by proActiv. This must contain a condition vector (i.e., the call to `proActiv` that returned this `result` must have had the `condition` vector supplied).    
- `geneId`. A character vector of the gene of interest. This identifier must correspond to the identifier in the promoter annotation.    
- `geneName`. A character vector of the gene of interest. The common gene name to be plotted. Optional and defaults to NULL.   
- `filterInternal`. A boolean variable that determines if internal promoters should be removed from the plot. Defaults to TRUE.     
- `col`. A character vector of colours for plotting. Defaults to NULL, which uses `ggplot2` default colours.    

Below, we call `boxplotPromoters` with RAP1GAP:
```{r Boxplot, eval=TRUE, message=FALSE, fig.align='center', fig.height=5, fig.width=7}
plots <- boxplotPromoters(result, "ENSG00000076864.19")

# Boxplot of absolute promoter activity
library(gridExtra)
grid.arrange(plots[[1]], plots[[3]], nrow = 1, ncol = 2, widths = c(3, 2))
```

The `plots` object stores the plot for absolute promoter activity, relative promoter activity and gene expression in the first, second and third slot respectively. The plot generated by `boxplotPromoters` reflect the alternative usage of promoters 137 and 141 as called by `getAlternativePromoters`.

### Promoter category proportion 

Here, we visualize the categorization of annotated promoters in the two cell lines. The proportions between the categories are similar across the two cell lines, with majority of the promoters being inactive. 

```{r VizPromoterCategories, eval=TRUE, fig.align='center', fig.height=5, fig.width=5, message=FALSE, warning=FALSE}
library(ggplot2)

rdata <- rowData(result)
## Create a long dataframe summarizing cell line and promoter class
pdata1 <- data.frame(cellLine = rep(c('A549', 'HepG2'), each = nrow(rdata)),
                       promoterClass = as.factor(c(rdata$A549.class, rdata$HepG2.class)))

ggplot(na.omit(pdata1)) +
  geom_bar(aes(x = cellLine, fill = promoterClass)) + 
  xlab('Cell Lines') + ylab('Count') +  labs(fill = 'Promoter Category') +
  ggtitle('Categorization of Promoters')
```

### Major/minor promoters by position

Analysis of major:minor promoter proportions against promoter position. The analysis is restricted to multi-promoter genes with at least one active promoter. Below, we generate the plot for cell line HepG2. In general, the major:minor promoter proportion decreases with increasing promoter position.

```{r VizMajorMinorPosition, eval=TRUE, fig.align='center', fig.height=5, fig.width=5, message=FALSE, warning=FALSE}
## Because many genes have many annotated promoters, we collapse promoters 
## from the 5th position and onward into one group for simplicity
pdata2 <- as_tibble(rdata) %>%
  mutate(promoterPosition = ifelse(promoterPosition > 5, 5, promoterPosition)) %>%
  filter(HepG2.class %in% c('Major', 'Minor'))

ggplot(pdata2) +
  geom_bar(aes(x = promoterPosition, fill = as.factor(HepG2.class)), position = 'fill') +
  xlab(expression(Promoter ~ Position ~ "5'" %->% "3'")) + ylab('Percentage') + 
  labs(fill = 'Promoter Category') + ggtitle('Major/Minor Promoter Proportion in HepG2') + 
  scale_y_continuous(breaks = seq(0,1, 0.25), labels = paste0(seq(0,100,25),'%')) +
  scale_x_continuous(breaks = seq(1,5), labels = c('1','2','3','4','>=5'))
```

### Major promoter activity and gene expression

Comparison of major promoter activity and gene expression, calculated by summing over all promoters. Single promoter genes lie on the diagonal. Multi-promoter genes lie to the right of the diagonal. Below, we generate the plot for cell line HepG2. This plot suggests that a single major promoter does not often fully explain gene expression, with minor promoters also contributing to gene expression.

```{r VizMajorGeneExp, eval=TRUE, fig.align='center', fig.height=5, fig.width=6.5, message=FALSE, warning=FALSE}
## Get active major promoters of HepG2
majorPromoter <- as_tibble(rdata) %>% group_by(geneId) %>% 
  mutate(promoterCount = n()) %>% filter(HepG2.class == 'Major') 

pdata3 <- data.frame(proActiv = majorPromoter$HepG2.mean,
                     geneExp = majorPromoter$HepG2.gene.mean,
                     promoterCount = majorPromoter$promoterCount)

ggplot(pdata3, aes(x = geneExp, y = proActiv)) + 
  geom_point(aes(colour = promoterCount), alpha = 0.5) +
  ggtitle('Major Promoter Activity vs. Gene Expression in HepG2') + 
  xlab('Average Gene Expression') + ylab('Average Major Promoter Activity') +
  labs(colour = 'Number of \n Annotated Promoters') +
  geom_abline(slope = 1, intercept = 0, colour = 'red', linetype = 'dashed')
```

### t-SNE 

We generate a t-SNE plot with all active promoters. Expectedly, replicates from each cell line cluster together. 

```{r VizTsne, eval=TRUE, fig.align='center', fig.height=5.2, fig.width=5.2}
library(Rtsne)

## Remove inactive promoters (sparse rows)
data <- assays(result)$absolutePromoterActivity %>% filter(rowSums(.) > 0)
data <- data.frame(t(data))
data$Sample <- as.factor(condition)

set.seed(40) # for reproducibility

tsne.out <- Rtsne(as.matrix(subset(data, select = -c(Sample))), perplexity = 1)
plot(x = tsne.out$Y[,1], y = tsne.out$Y[,2], bg = data$Sample, asp = 1,
     col = 'black', pch = 24, cex = 4,
     main = 't-SNE plot with promoters \n active in at least one sample',
     xlab = 'T-SNE1', ylab = 'T-SNE2',
     xlim = c(-300,300), ylim = c(-300,300))
legend('topright', inset = .02, title = 'Cell Lines',
       unique(condition), pch = c(24,24), pt.bg = 1:length(unique(condition)) , cex = 1.5, bty = 'n')
```

## Getting help

Questions and issues can be raised at the Bioconductor support site: https://support.bioconductor.org. Ensure your posts are tagged with `proActiv`. 

Alternatively, issues can be raised at the proActiv Github repository: https://github.com/GoekeLab/proActiv.

## Citing proActiv

If you use proActiv, please cite:

[Demircioğlu, Deniz, et al. "A Pan-cancer Transcriptome Analysis Reveals Pervasive Regulation through Alternative Promoters." *Cell* 178.6 (2019): 1465-1477.](https://www.cell.com/cell/fulltext/S0092-8674(19)30906-7)

## Session information

```{r SessionInfo, eval=TRUE, echo=FALSE}
sessionInfo()
```

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/proActiv.R
\name{integrateProactiv}
\alias{integrateProactiv}
\title{Integrate multiple proActiv runs}
\usage{
integrateProactiv(res1, res2, ..., promoterAnnotation, renormalize = TRUE)
}
\arguments{
\item{res1}{A summarizedExperiment object returned by proActiv}

\item{res2}{A summarizedExperiment object returned by proActiv}

\item{...}{Additional summarizedExperiment objects returned by proActiv}

\item{promoterAnnotation}{Promoter annotation object used to create 
proActiv runs}

\item{renormalize}{Whether to renormalize counts after merging. Defaults to 
TRUE}
}
\value{
A SummarizedExperiment object with assays giving promoter counts 
  and activity with gene expression. rowData contains
  promoter metadata and absolute promoter activity summarized across
  conditions (if condition is provided)
}
\description{
Integrate multiple proActiv runs
}
\examples{
f1 <- list.files(system.file('extdata/vignette/junctions', 
                             package = 'proActiv'), 
                 full.names = TRUE, pattern = 'A549')
f2 <- list.files(system.file('extdata/vignette/junctions', 
                             package = 'proActiv'), 
                 full.names = TRUE, pattern = 'HepG2')
promoterAnnotation <- promoterAnnotation.gencode.v34.subset
res1 <- proActiv(files = f1, promoterAnnotation  = promoterAnnotation,
                 condition = rep('A549',3))
res2 <- proActiv(files = f2, promoterAnnotation = promoterAnnotation,
                 condition = rep('HepG2',3))
res <- integrateProactiv(res1, res2, promoterAnnotation = promoterAnnotation)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{promoterAnnotation.gencode.v34.subset}
\alias{promoterAnnotation.gencode.v34.subset}
\title{Promoter annotation for Gencode.v34 (subset)}
\format{
A PromoterAnnotation (S4 Class) object containing all promoter
  annotation objects for Gencode.v34 chr1:10,000,000-30,000,000. 
  The object has 3 slots: \describe{
  \item{intronRanges}{A GRanges object of 4,523 ranges corresponding
  to introns, annotated with the associated transcript.} 
  \item{promoterIdMapping}{The id mapping between transcript names, 
  promoter ids and gene ids for Gencode v34.} 
  \item{promoterCoordinates}{A GRanges object of 1,380 ranges
  showing the tss coordinate for each promoter of Gencode v34 
  chr1:10,000,000-30,000,000, annotated with the associated gene id, 
  coordinate of the 3' end of the first reduced exon, and intron id.} }
}
\usage{
promoterAnnotation.gencode.v34.subset
}
\description{
Promoter annotation for Gencode.v34 
  (chr1:10,000,000 - 30,000,000)
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/PromoterAnnotation-class.R
\docType{class}
\name{PromoterAnnotation-class}
\alias{PromoterAnnotation-class}
\alias{PromoterAnnotation}
\alias{intronRanges}
\alias{intronRanges,PromoterAnnotation-method}
\alias{promoterIdMapping}
\alias{promoterIdMapping,PromoterAnnotation-method}
\alias{promoterCoordinates}
\alias{promoterCoordinates,PromoterAnnotation-method}
\alias{intronRanges<-}
\alias{intronRanges<-,PromoterAnnotation-method}
\alias{'intronRanges<-',PromoterAnnotation-method}
\alias{promoterIdMapping<-}
\alias{promoterIdMapping<-,PromoterAnnotation-method}
\alias{'promoterIdMapping<-',PromoterAnnotation-method}
\alias{promoterCoordinates<-}
\alias{promoterCoordinates<-,PromoterAnnotation-method}
\alias{'promoterCoordinates<-',PromoterAnnotation-method}
\title{S4 class for promoter annotation data for a specific annotation version}
\usage{
PromoterAnnotation(
  intronRanges = GenomicRanges::GRanges(),
  promoterIdMapping = data.frame(),
  promoterCoordinates = GenomicRanges::GRanges()
)

intronRanges(x)

\S4method{intronRanges}{PromoterAnnotation}(x)

promoterIdMapping(x)

\S4method{promoterIdMapping}{PromoterAnnotation}(x)

promoterCoordinates(x)

\S4method{promoterCoordinates}{PromoterAnnotation}(x)

intronRanges(x) <- value

\S4method{intronRanges}{PromoterAnnotation}(x) <- value

promoterIdMapping(x) <- value

\S4method{promoterIdMapping}{PromoterAnnotation}(x) <- value

promoterCoordinates(x) <- value

\S4method{promoterCoordinates}{PromoterAnnotation}(x) <- value
}
\arguments{
\item{intronRanges}{A GRanges object containing annotated intron ranges}

\item{promoterIdMapping}{A data.frame containing mapping between transcript, 
TSS, promoter and gene ids}

\item{promoterCoordinates}{A GRanges object containing promoter coordinates}

\item{x}{A PromoterAnnotation object}

\item{value}{intronRanges, promoterIdMapping or promoterCoordinates to 
be assigned}
}
\value{
A promoter annotation object with three slots: intronRanges, 
  promoterIdMapping and promoter Coordinates
}
\description{
S4 class for promoter annotation data for a specific annotation version
}
\section{Functions}{
\itemize{
\item \code{intronRanges}: Getter for intronRanges

\item \code{intronRanges,PromoterAnnotation-method}: Getter for intronRanges

\item \code{promoterIdMapping}: Getter for promoterIdMapping

\item \code{promoterIdMapping,PromoterAnnotation-method}: Getter for promoterIdMapping

\item \code{promoterCoordinates}: Getter for promoterCoordinates

\item \code{promoterCoordinates,PromoterAnnotation-method}: Getter for promoterCoordinates

\item \code{intronRanges<-}: Setter for intronRanges

\item \code{intronRanges<-,PromoterAnnotation-method}: Setter for intronRanges

\item \code{promoterIdMapping<-}: Setter for promoterIdMapping

\item \code{promoterIdMapping<-,PromoterAnnotation-method}: Setter for promoterIdMapping

\item \code{promoterCoordinates<-}: Setter for promoterCoordinates

\item \code{promoterCoordinates<-,PromoterAnnotation-method}: Setter for promoterCoordinates
}}

\section{Slots}{

\describe{
\item{\code{intronRanges}}{A GRanges object. The intron ranges annotated with the 
promoter information.}

\item{\code{promoterIdMapping}}{A data.frame object. The id mapping between 
transcript ids, names, TSS ids, promoter ids and gene ids.}

\item{\code{promoterCoordinates}}{A GRanges object. Promoter coordinates (TSS) with 
gene id and internal promoter state}
}}

\examples{

promoterAnnotation <- PromoterAnnotation()
intronRanges(promoterAnnotation) <- intronRanges(
                                    promoterAnnotation.gencode.v34.subset)
promoterIdMapping(promoterAnnotation) <- promoterIdMapping(
                                    promoterAnnotation.gencode.v34.subset)
promoterCoordinates(promoterAnnotation) <- promoterCoordinates(
                                    promoterAnnotation.gencode.v34.subset)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/junction-read-count.R
\name{calculateJunctionReadCounts}
\alias{calculateJunctionReadCounts}
\title{Calculate the total number of junction reads overlapping with the introns of
each promoter for the input junction file}
\usage{
calculateJunctionReadCounts(
  promoterCoordinates,
  intronRanges,
  file = "",
  fileType = "",
  genome = ""
)
}
\arguments{
\item{promoterCoordinates}{A GRanges object containing promoter coordinates
and reduced exon coordinates by gene}

\item{intronRanges}{A Granges object containing the annotated unique intron
ranges. These ranges will be used for counting the reads}

\item{file}{character path for the input junction bed or bam file}

\item{fileType}{character type of the junction bed file. Either 'tophat',
'star' or 'bam'}

\item{genome}{character genome version}
}
\value{
The total number of junction reads overlapping with each promoter for
  the input annotated intron ranges
}
\description{
Calculate the total number of junction reads overlapping with the introns of
each promoter for the input junction file
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/estimate-promoter-activity.R
\name{getGeneExpression}
\alias{getGeneExpression}
\title{Prepare the gene expression table including the gene ids}
\usage{
getGeneExpression(absolutePromoterActivity)
}
\arguments{
\item{absolutePromoterActivity}{data.frame of absolute promoter activity 
with promoter and gene ids}
}
\value{
data.frame of gene expression with gene ids#'
}
\description{
Prepare the gene expression table including the gene ids
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/estimate-promoter-activity.R
\name{getAbsolutePromoterActivity}
\alias{getAbsolutePromoterActivity}
\title{Prepare the absolute promoter activity table including the promoter and gene
ids}
\usage{
getAbsolutePromoterActivity(
  junctionReadCounts,
  promoterAnnotation,
  log2 = TRUE,
  pseudocount = 1
)
}
\arguments{
\item{junctionReadCounts}{Matrix of junction read counts (rows: promoters,
cols: samples)}

\item{promoterAnnotation}{A PromoterAnnotation object containing the
intron ranges, promoter coordinates and the promoter id mapping}

\item{log2}{Logical indicating whether log2 read counts should be used
(default: TRUE) or not}

\item{pseudocount}{Number to be used for log2 as pseudocount if log2 is TRUE}
}
\value{
data.frame of absolute promoter activity with promoter and gene ids
}
\description{
Prepare the absolute promoter activity table including the promoter and gene
ids
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plot-proActiv.R
\name{plotHeatmap}
\alias{plotHeatmap}
\title{Visualizes heatmap of features for samples}
\usage{
plotHeatmap(
  result,
  by = "absolutePromoterActivity",
  features = NULL,
  cex.legend = 0.75,
  cex.row = NULL,
  cex.col = NULL,
  row.margin = 5,
  col.margin = 12,
  col = NULL,
  breaks = NULL,
  palette = "bluered"
)
}
\arguments{
\item{result}{A SummarizedExperiment object return by proActiv, with assays 
giving promoter counts and activity with gene expression stored as 
metadata. rowData contains promoter metadata and absolute promoter 
activity summarized across conditions. Condition must be provided.}

\item{by}{A character vector. The assay to visualize the heatmap for. 
One of promoterCounts, normalizedPromoterCounts, 
absolutePromoterActivity and geneExpression (unambiguous substrings can be 
supplied). Defaults to absolutePromoterActivity.}

\item{features}{Features to visualize. Either a list of promoterIds or 
geneIds. The features must correspond to the assay is used, i.e., if 
promoter assays are used, features must be promoterIds, while if gene
expression assay is used, features must be geneIds. Defaults to NULL 
(visualizes all features of the assay).}

\item{cex.legend}{A numeric value. Legend size.}

\item{cex.row}{A numeric value. Row label size.}

\item{cex.col}{A numeric value. Column label size.}

\item{row.margin}{A numeric value. Row margins.}

\item{col.margin}{A numeric value. Column margins.}

\item{col}{A vector of colours. Length should correspond to number of 
experimental conditions. Defaults to NULL.}

\item{breaks}{A numeric vector. Breaks for heatmap plotting.}

\item{palette}{A character vector. One of bluered, redblue, redgreen, 
greenred. Defaults to bluered.}
}
\value{
Displays heatmap.
}
\description{
Visualizes heatmap of features for samples
}
\examples{
files <- list.files(system.file('extdata/vignette/junctions', 
                       package = 'proActiv'), 
                       full.names = TRUE, pattern = 'replicate5')
promoterAnnotation <- promoterAnnotation.gencode.v34.subset
result <- proActiv(files = files,
                       promoterAnnotation  = promoterAnnotation,
                       condition = rep(c('A549', 'HepG2'), each=1),
                       fileLabels = NULL,
                       ncores = 1)
result <- result[complete.cases(assays(result)[[1]]),] 
plotHeatmap(result)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/junction-read-count.R
\name{calculatePromoterReadCounts}
\alias{calculatePromoterReadCounts}
\title{Calculate the promoter read counts using junction read counts approach for
all the input junction files}
\usage{
calculatePromoterReadCounts(
  promoterAnnotation,
  files = NULL,
  fileLabels = NULL,
  fileType = NULL,
  genome = NULL,
  numberOfCores = 1
)
}
\arguments{
\item{promoterAnnotation}{A PromoterAnnotation object containing the
reduced exon ranges, annotated intron ranges, promoter coordinates and the
promoter id mapping}

\item{files}{A character vector. The list of junction or BAM files 
for which the junction read counts will be calculated}

\item{fileLabels}{A character vector. The labels of junction or BAM 
files for which the junction read counts will be calculated. These labels 
will be used as column names for the output data.frame object}

\item{fileType}{A character. Type of the junction bed or bam file, either
'tophat', 'star' or 'bam}

\item{genome}{A character. Genome version used. Must be specified if input is
a BAM file. Defaults to NULL}

\item{numberOfCores}{A numeric value. The number of cores to be used for
counting junction reads. Defaults to 1 (no parallelization). This parameter
will be used as an argument to BiocParallel::bplapply}
}
\value{
A data.frame object. The number of junction reads per promoter (rows)
  for each sample (cols)
}
\description{
Calculate the promoter read counts using junction read counts approach for
all the input junction files
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/junction-read-count.R
\name{normalizePromoterReadCounts}
\alias{normalizePromoterReadCounts}
\title{Normalize promoter read counts using DESeq2}
\usage{
normalizePromoterReadCounts(promoterReadCounts)
}
\arguments{
\item{promoterReadCounts}{A data.frame object. The number of junction reads
per promoter (rows) for each sample (cols)}
}
\value{
A data.frame object. The normalized number of junction reads per
  promoter (rows) for each sample (cols) using DESeq2 counts function.
  Requires 'DESeq2' package to be installed
}
\description{
Normalize promoter read counts using DESeq2
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/reexports.R
\docType{import}
\name{reexports}
\alias{reexports}
\alias{loadDb}
\alias{assays}
\alias{rowData}
\alias{colData}
\alias{as_tibble}
\alias{\%>\%}
\alias{group_by}
\alias{mutate}
\alias{filter}
\alias{n}
\alias{arrange}
\alias{rownames_to_column}
\title{Objects exported from other packages}
\keyword{internal}
\description{
These objects are imported from other packages. Follow the links
below to see their documentation.

\describe{
  \item{AnnotationDbi}{\code{\link[AnnotationDbi:AnnotationDb-class]{loadDb}}}

  \item{dplyr}{\code{\link[dplyr:reexports]{\%>\%}}, \code{\link[dplyr]{arrange}}, \code{\link[dplyr:reexports]{as_tibble}}, \code{\link[dplyr]{filter}}, \code{\link[dplyr]{group_by}}, \code{\link[dplyr]{mutate}}, \code{\link[dplyr:context]{n}}}

  \item{SummarizedExperiment}{\code{\link[SummarizedExperiment:SummarizedExperiment-class]{assays}}, \code{\link[SummarizedExperiment:SummarizedExperiment-class]{colData}}, \code{\link[SummarizedExperiment:SummarizedExperiment-class]{rowData}}}

  \item{tibble}{\code{\link[tibble:rownames]{rownames_to_column}}}
}}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/identify-alternative-promoters.R
\name{getAlternativePromoters}
\alias{getAlternativePromoters}
\title{Identifies alternative promoters.}
\usage{
getAlternativePromoters(
  result,
  referenceCondition,
  minAbs = 0.25,
  minRel = 0.05,
  maxPval = 0.05,
  promoterFC = 2,
  geneFC = 1.5
)
}
\arguments{
\item{result}{A SummarizedExperiment object with assays giving promoter 
counts, activity and gene expression (output from proActiv). rowData 
contains promoter metadata and absolute promoter activity summarized 
across conditions. Condition must be provided.}

\item{referenceCondition}{A character vector. The reference condition to be 
compared. Samples corresponding to all other conditions will be compared 
to this samples in this current condition.}

\item{minAbs}{A numeric value. Minimum value for promoter to be active in 
absolute terms. Defaults to 0.25.}

\item{minRel}{A numeric value. Minimum value for promoter to be active in 
relative terms. Defaults to 0.05.}

\item{maxPval}{A numeric value. Adjusted p-value threshold for detecting 
alternative promoters. Defaults to 0.05.}

\item{promoterFC}{A numeric value. Minimum fold change for a promoter in the
current condition compared to all other conditions. Promoters must have at 
least this magnitude of fold change for alternative usage.}

\item{geneFC}{A numeric value. Maximum fold change for gene expression. To
identify alternative promoter usage independent of changes in gene 
expression, limit the gene expression fold change.}
}
\value{
A list of length 2. Each entry is a dataframe summarizing 
 up-regulated and down-regulated promoters and their corresponding genes, 
 if any.
}
\description{
Identifies alternative promoters.
}
\examples{
 
files <- list.files(system.file('extdata/vignette/junctions', 
                       package = 'proActiv'), 
                       full.names = TRUE, pattern = 'replicate5')
promoterAnnotation <- promoterAnnotation.gencode.v34.subset
result <- proActiv(files = files,
                       promoterAnnotation  = promoterAnnotation,
                       condition = rep(c('A549', 'HepG2'), each=1),
                       fileLabels = NULL,
                       ncores = 1)
alternativePromoters <- getAlternativePromoters(result, "A549")

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plot-proActiv.R
\name{plotPCA}
\alias{plotPCA}
\title{Performs principal component analysis}
\usage{
plotPCA(
  result,
  by = "absolutePromoterActivity",
  main = NULL,
  col = NULL,
  alpha = 0.75,
  cex.size = 2
)
}
\arguments{
\item{result}{A SummarizedExperiment object return by proActiv, with assays 
giving promoter counts and activity with gene expression stored as 
metadata. rowData contains promoter metadata and absolute promoter 
activity summarized across conditions. Condition must be provided.}

\item{by}{A character vector. The assay to perform principal component 
analysis by. One of promoterCounts, normalizedPromoterCounts, 
absolutePromoterActivity and geneExpression (unambiguous substrings can be 
supplied). Defaults to absolutePromoterActivity.}

\item{main}{A character vector. Plot title (optional). Defaults to NULL.}

\item{col}{A vector of colours. If NULL, uses standard ggplot colours. 
Defaults to NULL.}

\item{alpha}{A numeric value in between 0 and 1. Determines point 
transparency.}

\item{cex.size}{A numeric value. Determines point size.}
}
\value{
PCA plot.
}
\description{
Performs principal component analysis
}
\examples{
files <- list.files(system.file('extdata/vignette/junctions', 
                       package = 'proActiv'), 
                       full.names = TRUE, pattern = 'replicate5')
promoterAnnotation <- promoterAnnotation.gencode.v34.subset
result <- proActiv(files = files,
                       promoterAnnotation  = promoterAnnotation,
                       condition = rep(c('A549', 'HepG2'), each=1),
                       fileLabels = NULL,
                       ncores = 1)
result <- result[complete.cases(assays(result)[[1]]),]
plotPCA(result)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/proActiv.R
\name{proActiv}
\alias{proActiv}
\title{Estimates promoter counts and activity in a single command}
\usage{
proActiv(
  files,
  promoterAnnotation,
  fileLabels = NULL,
  condition = NULL,
  genome = NULL,
  ncores = 1
)
}
\arguments{
\item{files}{A character vector. The list of input files for 
which the junction read counts will be calculated}

\item{promoterAnnotation}{A PromoterAnnotation object containing the
intron ranges, promoter coordinates and the promoter id mapping}

\item{fileLabels}{A character vector. The labels of input files 
for which the junction read counts will be calculated. These labels will be 
used as column names for each output data.frame object. If not provided,
filenames will be used as labels. Defaults to NULL}

\item{condition}{A character vector. The condition to which each sample
belong to. Must correspond to the order of the files. If supplied, 
results are summarized by condition. Defaults to NULL}

\item{genome}{A character. Genome version. Must be specified if input file
type is a BAM file. Defaults to NULL}

\item{ncores}{A numeric value. The number of cores to be used for 
counting junction reads. Defaults to 1 (no parallelization). This parameter 
will be used as an argument to BiocParallel::bplapply}
}
\value{
A SummarizedExperiment object with assays giving promoter counts 
  and activity with gene expression. rowData contains
  promoter metadata and absolute promoter activity summarized across
  conditions (if condition is provided)
}
\description{
Estimates promoter counts and activity in a single command
}
\examples{

files <- list.files(system.file('extdata/vignette/junctions', 
                       package = 'proActiv'), 
                       full.names = TRUE, pattern = 'replicate5')
promoterAnnotation <- promoterAnnotation.gencode.v34.subset
result <- proActiv(files = files,
                       promoterAnnotation  = promoterAnnotation,
                       condition = rep(c('A549', 'HepG2'), each=1),
                       fileLabels = NULL,
                       ncores = 1)
                           
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/annotation-data.R
\name{preparePromoterAnnotation}
\alias{preparePromoterAnnotation}
\title{Prepares promoter annotation from a gtf or txdb}
\usage{
preparePromoterAnnotation(txdb, file, species)
}
\arguments{
\item{txdb}{A txdb object. The txdb of the annotation version for which
promoters will be identified. Either `txdb` or `file` argument must be 
specified, but not both.}

\item{file}{A character object. The file path to a gtf/gff or txdb of the 
annotation version for which promoters will be identified. Either `txdb` 
or `file` argument must be specified, but not both.}

\item{species}{A character object. The genus and species of the organism to
be used in keepStandardChromosomes(). Supported species can be seen with
names(genomeStyles()).}
}
\value{
A PromoterAnnotation object. The annotated
  intron ranges, promoter coordinates and the promoter id mapping are
  attributes of the promoter annotation data.
}
\description{
Prepares promoter annotation from a gtf or txdb
}
\examples{

txdbPath <- system.file('extdata/vignette/annotations/',
                            'gencode.v34.annotation.subset.sqlite', 
                             package = 'proActiv')
txdb <- AnnotationDbi::loadDb(txdbPath)
promoterAnnotation <- preparePromoterAnnotation(txdb = txdb,
                                                species = 'Homo_sapiens')

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/estimate-promoter-activity.R
\name{getRelativePromoterActivity}
\alias{getRelativePromoterActivity}
\title{Prepare the relative promoter activity table including the promoter and gene
ids}
\usage{
getRelativePromoterActivity(absolutePromoterActivity, geneExpression)
}
\arguments{
\item{absolutePromoterActivity}{data.frame of absolute promoter activity with
promoter and gene ids}

\item{geneExpression}{data.frame of gene expression with gene ids}
}
\value{
data.frame of relative promoter activity with promoter and gene ids
}
\description{
Prepare the relative promoter activity table including the promoter and gene
ids
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plot-proActiv.R
\name{boxplotPromoters}
\alias{boxplotPromoters}
\title{Visualizes promoter activity and gene expression with boxplots}
\usage{
boxplotPromoters(
  result,
  geneId,
  geneName = NULL,
  filterInternal = TRUE,
  col = NULL
)
}
\arguments{
\item{result}{A SummarizedExperiment object return by proActiv, with assays 
giving promoter counts and activity with gene expression stored as 
metadata. rowData contains promoter metadata and absolute promoter 
activity summarized across conditions. Condition must be provided.}

\item{geneId}{A character vector. A single gene id. This identifier must
correspond to the identifier in the promoter annotation.}

\item{geneName}{A character vector. Common gene name to be displayed
on plot. Optional. Defaults to NULL.}

\item{filterInternal}{A boolean. Determines if internal promoters should be 
removed from the plot. Defaults to TRUE.}

\item{col}{A character vector of colours to be used for plotting.}
}
\value{
A list of length 3. Each entry is a plot corresponding to 
 absolute promoter activity, relative promoter activity and gene expression.
}
\description{
Visualizes promoter activity and gene expression with boxplots
}
\examples{
files <- list.files(system.file('extdata/vignette/junctions', 
                       package = 'proActiv'), 
                       full.names = TRUE, pattern = 'replicate5')
promoterAnnotation <- promoterAnnotation.gencode.v34.subset
result <- proActiv(files = files,
                       promoterAnnotation  = promoterAnnotation,
                       condition = rep(c('A549', 'HepG2'), each=1),
                       fileLabels = NULL,
                       ncores = 1)
plots <- boxplotPromoters(result, "ENSG00000076864.19")

}
